
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CreateProfile extends HttpServlet
{
 private ConnectionPool connPool;
 private int MAXSIZE=512;

 protected int initialConnection()
 {
  return(10);
 }

 protected int maxConnections()
 {
  return(50);
 }

 public void init() throws ServletException
 {
  String driver="org.gjt.mm.mysql.Driver";
  String url="jdbc:mysql://richese.csci.unt.edu/chindraw";
  String user="chindraw";
  String pwd="chindraw";
  try
  {
   connPool=new ConnectionPool(driver,url,user,pwd,
                               initialConnection(),
                               maxConnections(),
                               true); 
  }
  catch(SQLException sqle)
  {
   System.err.println("Error making pool:"+sqle);
   getServletContext().log("Error making pool:"+sqle);
   connPool = null;   
  }
 }

 public void destroy()
 {
  connPool.closeAllConnections();
 }

 public void doGet(HttpServletRequest request,
                   HttpServletResponse response)
                   throws ServletException, IOException
 {
  doPost(request,response);
 } 

 public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
                    throws ServletException, IOException
 {
  ResultSet rs;
  Statement stmt;
  boolean errorFlag = false;
  PrintWriter out = response.getWriter();
  StringBuffer sql = new StringBuffer(MAXSIZE);
  StringBuffer tempOrder = new StringBuffer(MAXSIZE);
  StringBuffer newUser = new StringBuffer(MAXSIZE);
  Connection connection = connPool.getConnection();

  response.setContentType("text/html");


  String nextURL = "http://jsp.csci.unt.edu/chindraw/user_menu.html";
  String encodedURL = response.encodeURL(nextURL);

  String userName = request.getParameter("username");
  String emailAddr= request.getParameter("emailAdd");
  String password1= request.getParameter("pre_pwd");
  String password2= request.getParameter("final_pwd");
  String theDept  = request.getParameter("dept");

  if(userName.length() < 1)
  {
    out.println("<P>Need to input user name</P>\n");
    errorFlag = true;
  }      
  if(emailAddr.length() < 1)
  {
    out.println("<P>Need to input email address</p>\n");
    errorFlag = true;
  }
  if(password1.length() < 1)
  {
    out.println("<P>Need to input password</P>\n");
    errorFlag = true;
  }
  if(password2.length() < 1)
  {
    out.println("<P>Need to input confirmation of the password</p>\n");
    errorFlag = true;
  }
  if(password1.compareTo(password2) != 0)
  {
    out.println("<P>Need to have re-enter the confirmation password</p>\n");
    errorFlag = true;
  }
  if(theDept.length() < 1)
  {
    out.println("<P>Need to enter the dept that you work.</p>\n");
    errorFlag = true;
  }

  if(errorFlag)
  {
    out.println("<p>Press the BACK botton on your browser and" +
                " re-enter the missing fields or reconfirm the password</p>");
    return;
  }

  
  try
  {
    sql.append("SELECT * FROM myuser");
    stmt = connection.createStatement();   
    rs = stmt.executeQuery(sql.toString());
    while(rs.next())
    {
      if(rs.getString(1).compareToIgnoreCase(userName)==0)
       if(rs.getString(2).compareToIgnoreCase(emailAddr)==0)
        if(rs.getString(3).compareToIgnoreCase(password1)==0)
        {
         //user must have register since the name and email are found
         //in the database. Even the password is matched.
         out.println("<P>You must have register before in this site."+
                     "If you think this is a mistake, please contact"+
                     " sysadmin@cs.unt.edu</p>\n");
         out.println("<P>Else please continue by clicking the link "+
                     "below</p>\n");
         HttpSession session = request.getSession(true);
         session.putValue("user_session",userName);
         out.println("<a href=\""+encodedURL+"\">Click here</a>");.
         return;
        }
    } // end of while-loop

    sql.delete(0,sql.length());

    newUser.append("INSERT INTO myuser VALUE(\""+userName+"\".\""+
                   emailAddr+"\".\""+password1+"\".\""+dept+"\"\")");   
    tempOrder,append("INSERT INTO myorder VALUES(\""+emailAddr+"\")");

    stmt.executeUpdate(newUser.toString());
    stmt.executeUpdate(tempOrder.toString());

  }
  catch(SQLException e)
  {
    response.sendError(response.SC_ACCEPTED, "The request has been " +
	               "accepted, but it failed to complete due to " +
		       "an error querying the database.");
    out.println(e);
    return;
  }
  
  HttpSession session = request.getSession(true);
  session.putValue("user_session",userName);
  response.sendRedirect(encodedURL);
 } // end of doPost's method

} // end of CreateProfile.java
