/**
 * File: MemberLogin.java
 * Author: Ken-Yinn Chung, Edision Chindrawaly
 * Date: 2.17.2001
 */

import java.sql.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class MemberLogin extends HttpServlet {
    Connection dbConn;

    // Make connection to database
    public void init() throws ServletException {
	String driver = "org.gjt.mm.mysql.Driver";
	String url = "jdbc:mysql://richese.csci.unt.edu/chung";
	String user = "chung";
	String pwd = "chung";

	try{
	    Class.forName(driver);
	    dbConn = DriverManager.getConnection(url, user, pwd);
	} catch(ClassNotFoundException e) {
	    System.out.println("Database driver class not found.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "JDBC driver class not found");
	} catch(SQLException e) {
	    System.out.println("Error connecting to the database.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "Cannot connect to the database");
	}
    } // end init


    public void doPost(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {

	ResultSet rs;
	Statement stmt;
	StringBuffer sql = new StringBuffer(512);
	StringBuffer member = new StringBuffer(512);
	StringBuffer contact = new StringBuffer(512);
	StringBuffer has = new StringBuffer(512);
	PrintWriter out = response.getWriter();
	Vector missing = new Vector();
	int msize;
	String name;
        String correctURL
	    ="http://jsp.csci.unt.edu/chung/correctLogin.html";
 	String incorrectURL
	    ="http://jsp.csci.unt.edu/chung/incorrectLogin.html";

	response.setContentType("text/html");

	// Create HTML page
	out.println("<HTML>\n\n" +
		    "<HEAD>\n" +
		    "  <TITLE>UNT Alumni</TITLE>\n" +
		    "</HEAD>\n\n" +
		    "<BODY>\n");

	// Get field values and check their validitions
	String email = request.getParameter("email");
	if (email.length() == 0)
	    missing.add("E-mail Address");

	String pwd = request.getParameter("password");
	if (pwd.length() == 0)
	    missing.add("Password");

	// Print error messages for missing entries
	if ((msize = missing.size()) > 0) {
	    for (int i = 0; i < msize; i++) {
		out.println((String) missing.get(i) + " is missing.<P>");
	    } 

	    out.println("\nPlease press the BACK botton on your " +
			"browser to enter missing/invalid entries.");	    
	    return;
	}


	// Verify login member
	try {
	    stmt = dbConn.createStatement();

	    sql.append("SELECT password FROM member " +
		       "WHERE email=\"" + email + "\"");
	    rs = stmt.executeQuery(sql.toString());

	    if (rs.getString(1) != null && 
		pwd.compareTo(rs.getString(1)) == 0) {
		sql.delete(0, sql.length());
		sql.append("SELECT lastName, firstName FROM member " +
			   "WHERE email=\"" + email + "\"");
		rs = stmt.executeQuery(sql.toString());
		name = rs.getString(2) + " " + rs.getString(1);
	        response.sendRedirect(response.encodeURL(correctURL));	
	    }
	    else {
		response.sendRedirect(response.encodeURL(incorrectURL));
	    }
	} catch (SQLException e) {
	    response.sendError(response.SC_ACCEPTED, "The request has been " +
			       "accepted, but it failed to complete due to " +
			       "an error querying the database.");
	    out.println(e);
	    return;
	}

	out.println("</BODY>\n" +
		    "</HTML>");
    } // end doPost


    public void destroy() {
	try {
	    dbConn.close();
	} catch (Exception e) {
	    System.out.println("Database close failed.");
	    System.out.println(e);
	}
    }
}





