/**
 * File: Search.java
 * Author: Ken-Yinn Chung, Edision Chindrawaly
 * Date: 2.17.2001
 */

import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class Search extends HttpServlet {
    Connection dbConn;

    public void init() throws ServletException {
	String driver = "org.gjt.mm.mysql.Driver";
	String url = "jdbc:mysql://richese.csci.unt.edu/chung";
	String user = "chung";
	String pwd = "chung";

	try {
	    Class.forName(driver);
	    dbConn = DriverManager.getConnection(url, user, pwd);
	} catch(ClassNotFoundException e) {
	    System.out.println("Database driver class not found.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "JDBC driver class not found.");
	} catch(SQLException e) {
	    System.out.println("Eror connecting to the database.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "Cannot connect to the database.");
	}
    } // end init


    public void doPost(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {

	int size;
	ResultSet rs, rs1;
	Statement stmt, stmt1;
	PrintWriter out = response.getWriter();
	StringBuffer sql = new StringBuffer(512);
	String email = new String();
	Vector member = new Vector();
	Vector contact = new Vector(); 
	Vector rs_cp = new Vector();
	String notFound[] = new String[3];

	String iURL = "http://jsp.csci.unt.edu/chung/incorrectParam.html";
	String fName = request.getParameter("firstname");
	String lName = request.getParameter("lastname");
	String eMail = request.getParameter("email");

	boolean emptyFirstName = false;
	boolean emptyLastName = false;
	boolean emptyEmail = false; 
	boolean foundThem[] = new boolean[3];
	boolean first = true;

	foundThem[0] = true;
	foundThem[1] = true;
	foundThem[2] = true;

	response.setContentType("text/html");
 
	//check to see users fill at least one field.
	if(fName.length() < 1)
	    emptyFirstName = true;
	if(lName.length() < 1)
	    emptyLastName = true;
	if(eMail.length() < 1)
	    emptyEmail = true;
 
	if(emptyEmail && emptyLastName && emptyFirstName)
	    response.sendRedirect(response.encodeURL(iURL));
 
	out.println("<html>\n<head>\n  <title>Search Result</title>\n</head>");
	out.println("<body bgcolor=ivory text=black link=blue alink=magneta " +
		    "vlink=green>");

	try {
	    stmt = dbConn.createStatement();
	    stmt1 = dbConn.createStatement();
 
	    // Search by e-mail
	    if(!emptyEmail) {
		sql.append("SELECT email FROM member " + 
			   "WHERE email=\"" + eMail + "\""); 
		rs = stmt.executeQuery(sql.toString());
   
		// Retrieve user's info from db if e-mail found
		if (rs.next()) {
		    // Retrieve data from member table
		    sql.delete(0, sql.length());
		    sql.append("SELECT * FROM member " +
			       "WHERE email=\"" + eMail + "\"");
		    rs = stmt.executeQuery(sql.toString());
		    for(int i = 1; i <= 8; i++)
			member.addElement(rs.getString(i));

		    // Retrieve data from contact table
		    sql.delete(0, sql.length());
		    sql.append("SELECT * FROM contact " +
			       "WHERE email=\"" + eMail + "\"");
		    rs = stmt.executeQuery(sql.toString());
		    for(int i = 1; i <= 7; i++)
			contact.addElement(rs.getString(i));

		    createFoundForm(first, out, member, contact, "email",
				    eMail);  

		    member.removeAllElements();
		    contact.removeAllElements();
		} // end if(rs.next())

		else {
		    foundThem[0] = false;
		    notFound[0] = eMail;
		}
	    } // end if(!emptyEmail)

	    // Search by first name
	    if(!emptyFirstName) {
		// Retrieve data from member table
		sql.delete(0, sql.length());
		sql.append("SELECT * FROM member " +
			   "WHERE firstName=\"" + fName + "\"");
		rs = stmt.executeQuery(sql.toString());
		if (rs.next()) {
		    do {
			email = rs.getString(8);
			for (int i = 1; i <= 8; i++)
			    member.addElement(rs.getString(i));

			// Retrieve data from contact table
			sql.delete(0,sql.length());
			sql.append("SELECT * FROM contact " +
				   "WHERE email=\"" + email + "\"");
			rs1 = stmt1.executeQuery(sql.toString());
			for (int i = 1; i <= 7; i++)
			    contact.addElement(rs1.getString(i));

			createFoundForm(first, out, member, contact,
					"first name", fName);

			first = false;
			member.removeAllElements();
			contact.removeAllElements();
		    } while(rs.next());

		    first = true;
		}
		else {
		    foundThem[1] = false;
		    notFound[1] = fName;
		}
	    } // end if(!emptyFirstName)

	    // Search by last name
	    if(!emptyLastName) {
		// Retrieve data from member table
		sql.delete(0, sql.length());
		sql.append("SELECT * FROM member " +
			   "WHERE lastName=\"" + lName + "\"");
		rs = stmt.executeQuery(sql.toString());
		if (rs.next()) {
		    do {
			email = rs.getString(8);
			for (int i = 1; i <= 8; i++)
			    member.addElement(rs.getString(i));

			// Retrieve data from contact table
			sql.delete(0,sql.length());
			sql.append("SELECT * FROM contact " +
				   "WHERE email=\"" + email + "\"");
			rs1 = stmt1.executeQuery(sql.toString());
			for (int i = 1; i <= 7; i++)
			    contact.addElement(rs1.getString(i));

			createFoundForm(first, out, member, contact,
					"last name", lName);

			first = false;
			member.removeAllElements();
			contact.removeAllElements();
		    } while (rs.next());

		    first = true;
		}
		else {
		    foundThem[2] = false;
		    notFound[2] = lName; 
		}
	    } // end if(!emptyLastName)

	    for (int i = 0; i < 3; i++) {
		if (!foundThem[i]) {
		    createNotFoundForm(out, notFound, foundThem);
		    break;
		}
	    } // end for loop
	} catch(SQLException e) {
	    response.sendError(response.SC_ACCEPTED,"The request has been" +
			       "accepted, but it failed to complete due to" +
			       "an eror querying the database. ");
	    out.println(e);
	    return;
	}

	out.println("<BR><BR><BR>");
	out.println("|&nbsp;<a href=../index.html>Home</a>&nbsp;"+
		    "|&nbsp;<a href=../reg_form.html>Register</a>&nbsp;"+
		    "|&nbsp;<a href=../search.html>Search Again</a>&nbsp;" +
		    "|&nbsp;<a href=../update_login.html>" +
		    "Update Information</a>&nbsp;|");
	out.println("</body>\n</html>");

    } // end doPost


    public void doGet(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {

	doPost(request,response);
    } // end doGet


    public void createFoundForm(boolean first, PrintWriter out, Vector member,
				Vector contact, String inStr1, String inStr2)
	throws ArrayIndexOutOfBoundsException {

	if (first) {
	    out.println("<BR></BR>");
	    out.println("<font face=arial>");
	    out.println("<b>Search finds </b>");
	    out.println(" by " + inStr1 + " criteria: " + inStr2);
	    out.println("</font>");
	    out.println("<BR></BR>");
	}
	out.println("<HR></HR>");
	out.println("<table width=100%>");
	out.println("<tr>");
	out.println("<td width=20%>First Name: </td>");  
	out.println("<td width=80%>" + (String) member.elementAt(1) + "</td>");
	out.println("</tr>");
	out.println("<tr>");
	out.println("<td>Last Name: </td>");
	out.println("<td>" + (String) member.elementAt(0) + "</td>");
	out.println("</TR>");
	out.println("<TR>");
	out.println("<TD>Date of Birth: </TD>");
	out.println("<TD>" + (String) member.elementAt(2) + "</td>");
	out.println("</TR>");
	out.println("<TR>");
	out.println("<TD>Telephone: </TD>");
	out.println("<TD> " + (String) contact.elementAt(1) + "</td>");
	out.println("</TR>");
	out.println("<TR>");
	out.println("<TD>Street Address: </TD>");
	out.println("<TD>" + (String) contact.elementAt(2) + "</TD>");
	out.println("</TR>");
	out.println("<TR>");
	out.println("<TD>City: </td>");
	out.println("<td>" + (String) contact.elementAt(3) + "</td>");
	out.println("</tr>");
	out.println("<TR>");
	out.println("<TD>State: </td>");
	out.println("<TD>" + (String) contact.elementAt(4) + "</td>");
	out.println("</tr>");
	out.println("<TR>");
	out.println("<TD>ZIP: </TD>");
	out.println("<TD>" + (String) contact.elementAt(5) + "</td>");
	out.println("</TR>");
	out.println("<TR>");
	out.println("<TD>Country: </td>");
	out.println("<TD>" + (String) contact.elementAt(6) + "</td>");
	out.println("</TR>");
	out.println("<TR>");
	out.println("<TD>E-mail Address: </td>");
	out.println("<td>" + (String) member.elementAt(7) + "</td>");
	out.println("</tr>");
	out.println("<TR>");
	out.println("<TD>Degree: </TD>");    
	out.println("<TD>" + (String) member.elementAt(3) + "</td>");
	out.println("</TR>");
	out.println("<TR>");
	out.println("<TD>Major: </td>");
	out.println("<td> " + (String) member.elementAt(4) + "</td>");
	out.println("</TR>");
	out.println("<tr>");
	out.println("<TD>Graduation Date: </td>");
	out.println("<TD>" + (String) member.elementAt(5) + "</td>");
	out.println("</tr>");
	out.println("</table>");
    } // end createFoundForm


    public void createNotFoundForm(PrintWriter out, String[] notFound,
				   boolean[] foundThem) {
	out.println("<br></br>");
	out.println("<font face=arial>");
	out.println("<p>Search can not find the following:</p> ");
	out.println("<OL>");

	for(int i = 0; i < 3; i++) {
	    if(!foundThem[i]) {
		switch(i) {
		case 0:out.println("<LI>Search by email failed to locate <B>" +
				   notFound[i] +
				   "</B> in the UNT Alumni Database.");
		       break;

		case 1:out.println("<LI>Search by first name failed to " +
				   "locate <B>" + notFound[i] +
				   "</B> in the UNT Alumni Database.");
		       break;

		case 2:out.println("<LI>Search by last name failed to " + 
				   "locate <B>" + notFound[i] +
				   "</B> in the UNT Alumni Database.");
		       break;
		}
	    }
	}

	out.println("</OL>");
	out.println("</font>");
    } // end createNotFoundForm


    public void destroy() {
	try {
	    dbConn.close();
	} catch(Exception e) {
	    System.out.println("Database close failed");
	    System.out.println(e);
	}
    } // end destroy
}
