/**
 * File: Update.java
 * Author: Ken-Yinn Chung, Edision Chindrawaly
 * Date: 2.17.2001
 */

import java.sql.*;
import java.io.*;
import java.util.*;
import java.lang.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class Update extends HttpServlet {
    Connection dbConn;

    // Make connection to database
    public void init() throws ServletException {
	String driver = "org.gjt.mm.mysql.Driver";
	String url = "jdbc:mysql://richese.csci.unt.edu/chung";
	String user = "chung";
	String pwd = "chung";

	try{
	    Class.forName(driver);
	    dbConn = DriverManager.getConnection(url, user, pwd);
	} catch(ClassNotFoundException e) {
	    System.out.println("Database driver class not found.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "JDBC driver class not found");
	} catch(SQLException e) {
	    System.out.println("Error connecting to the database.");
	    System.out.println(e);
	    throw new UnavailableException(this,
					   "Cannot connect to the database");
	}
    } // end init

    public void doPost(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {

	ResultSet rs;
	Statement stmt;
	StringBuffer sql = new StringBuffer(512);
	StringBuffer member = new StringBuffer(512);
	StringBuffer contact = new StringBuffer(512);
	StringBuffer has = new StringBuffer(512);
	PrintWriter out = response.getWriter();
	Vector missing = new Vector();
	int msize;
	boolean new_pwd = false;
	String vpwd = new String();

	response.setContentType("text/html");

	// Get field values and check their validitions
	String firstName = request.getParameter("firstName");
	if (firstName.length() == 0)
	    missing.add("First Name");

	String lastName = request.getParameter("lastName");
	if (lastName.length() == 0)
	    missing.add("Last Name");

	String dob = request.getParameter("DOB");
	if (dob.length() == 0)
	    missing.add("Date of Birth");

	String phone = request.getParameter("phone");
	if (phone.length() == 0)
	    missing.add("Telephone");

	String country = request.getParameter("country");
	if (country.length() == 0)
	    missing.add("Country");

	String zip = request.getParameter("zip");
	if (country.compareTo("United States") == 0 && zip.length() == 0)
	    missing.add("Zip Code");

	String state = request.getParameter("state");
	if (country.compareTo("United States") == 0 && state.length() == 0)
		missing.add("State");

	String city = request.getParameter("city");
	if (city.length() == 0)
	    missing.add("City");

	String street = request.getParameter("street1");
	if (street.length() == 0)
	    missing.add("Street");
	else if (request.getParameter("street2").length() > 0)
	    street = street + "\n" + request.getParameter("street2");

	String email = request.getParameter("email");
	if (email.length() == 0)
	    missing.add("E-mail Address");

	String login_email = request.getParameter("loginEmail");

	String pwd = request.getParameter("password");
	if (pwd.length() == 0)
	    pwd = request.getParameter("opassword");	
	else {
	    new_pwd = true;
	    vpwd = request.getParameter("vpassword");
	    if (vpwd.length() == 0)
		missing.add("Password Verification");
	}

	String degType = request.getParameter("degType");
	if (degType.length() == 0)
	    missing.add("Degree");

	String major = request.getParameter("major");
	if (major.length() == 0)
	    missing.add("Major");

	String gradDate = request.getParameter("gradDate");
	if (gradDate.length() == 0)
	    missing.add("Graduation Date");

	// Print error messages for missing entries
	if ((msize = missing.size()) > 0) {
	    for (int i = 0; i < msize; i++) {
		out.println((String) missing.get(i) + " is missing.<P>");
	    } 

	    out.println("\nPlease press the BACK botton on your " +
			"browser to enter missing/invalid entries.");	    
	    return;
	}

	// Verify existing user (last name, first name, e-mail
	try {
	    stmt = dbConn.createStatement();
	    
	    // Retrieve first name, last name, and email for verification
	    sql.delete(0, sql.length());
	    sql.append("SELECT lastName, firstName, email FROM member " +
		       "WHERE email!=\"" + login_email + "\"");
	    rs = stmt.executeQuery(sql.toString());

	    while (rs.next()) {
	        if (rs.getString(1).compareToIgnoreCase(lastName) == 0 &&
		    rs.getString(2).compareToIgnoreCase(firstName) == 0) {
		    out.println("Member " + firstName + " " + lastName + 
				" has already registered.");
		    out.println("<P>\nPlease contact the UNT Alumni by " +
				"sending e-mail to " +
				"<A HREF=\"mailto:UNTAlumni@unt.edu\">" +
				"UNTAlumni@unt.edu</A>.");
		    return;
	        }

		if (rs.getString(3).compareToIgnoreCase(email) == 0) {
		    out.println("E-mail has already been used.");
		    out.println("Please press the BACK botton on your " +
				"browser to enter your e-mail address again.");
		    out.println("<P>If you have enter a correct e-mail " +
				" address, you might have already " +
				"registered, so please contact the UNT " +
				"Alumni by sending e-mail to " +
				"<A HREF=\"mailto:UNTAlumni@unt.edu\">" +
				"UNTAlumni@unt.edu</A>.");
		    return;
		}
	    }
	} catch (SQLException e) {
	    response.sendError(response.SC_ACCEPTED, "The request has been " +
			       "accepted, but it failed to complete due to " +
			       "an error querying the database.");
	    out.println(e);
	    return;
	}

	// Verify password
	if (new_pwd && pwd.compareTo(vpwd) != 0) {
	    out.println("Password verification failed.");
	    out.println("<P>\nPlease press the BACK botton on your browser " +
			"to re-enter your password.");
	    return;
	}


	// Create sql statements
	member.append("UPDATE member " +
		      "SET lastName=\"" + lastName + "\", firstName=\"" +
		      firstName + "\", dob=\"" + dob + "\", degreeType=\"" +
		      degType + "\", major=\"" + major + "\", gradDate=\"" +
		      gradDate + "\", password=\"" + pwd + "\", email=\"" +
		      email + "\" WHERE email=\"" + login_email + "\"");

	contact.append("UPDATE contact " +
		       "SET email=\"" + email + "\", phone=\"" + phone +
		       "\", street=\"" + street + "\", city=\"" + city +
		       "\", state=\"" + state + "\", zip=\"" + zip +
		       "\", country=\"" + country +
		       "\" WHERE contact.email=\"" + login_email + "\"");

	has.append("UPDATE has SET email=\"" + email +
		   "\" WHERE email=\"" + login_email + "\"");

	// Excute update
	try {
	    stmt.executeUpdate(member.toString());
       	    stmt.executeUpdate(contact.toString());
	    stmt.executeUpdate(has.toString());
	} catch (SQLException e) {
	    response.sendError(response.SC_ACCEPTED, "The request has been " +
			       "accepted, but it failed to complete due to " +
			       "an error updating the database.");
	    out.println(e);
	    return;
	}

	// Have to put a registration confirmation page

	// For testing purpose, get data from member
	try {
	    sql.delete(0, sql.length());
	    sql.append("SELECT * FROM member");
	    rs = stmt.executeQuery(sql.toString());
	}
	catch (SQLException e) {
	    response.sendError(response.SC_ACCEPTED, "The request has been " +
			       "accepted, but it failed to complete due to " +
			       "an error querying the database.");
	    out.println(e);
	    return;
	}

	// Create HTML
	out.println("<html>\n<head>\n  <title>Update confirmation</title>");
	out.println("</head>");
	out.println("<body bgcolor=ivory text=black link=blue alink=magneta " +
		    "vlink=green>");
	out.println("You have successfully updated your information.");
	out.println("<BR><BR><BR>");
	out.println("|&nbsp;<a href=../index.html>Home</a>&nbsp;"+
		    "|&nbsp;<a href=../reg_form.html>Register</a>&nbsp;"+
		    "|&nbsp;<a href=../search.html>Search Again</a>&nbsp;" +
		    "|&nbsp;<a href=../update_login.html>" +
		    "Update Information</a>&nbsp;|");
	out.println("</body>\n</html>");
    } // end doPost


    public void destroy() {
	try {
	    dbConn.close();
	} catch (Exception e) {
	    System.out.println("Database close failed.");
	    System.out.println(e);
	}
    } // end destroy
}
