
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CancelOrder extends HttpServlet {

  private ConnectionPool connPool;
  private int MAXSIZE=512;

  protected int initialConnection() {
    return(10);
  }

  protected int maxConnections() {
    return(50);
  }

  public void init() throws ServletException {
    String driver="org.gjt.mm.mysql.Driver";
    String url="jdbc:mysql://richese.csci.unt.edu/chung";
    String user="chung";
    String pwd="chung";

    try {
      connPool=new ConnectionPool(driver, url, user, pwd, initialConnection(),
				  maxConnections(), true); 
    } catch(SQLException sqle) {
      System.err.println("Error making pool:"+sqle);
      getServletContext().log("Error making pool:"+sqle);
      connPool = null;   
    }
  }

  public void destroy() {
    connPool.closeAllConnections();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    doPost(request,response);
  } 

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

    ResultSet rs;
    Statement stmt;
    String status = new String();
    PrintWriter out = response.getWriter();
    StringBuffer sql = new StringBuffer(MAXSIZE);

    //String nextURL = "http://jsp.csci.unt.edu/chung/user_menu.jsp";
    //String encodedURL = response.encodeURL(nextURL);

    response.setContentType("text/html");

    String userName = request.getParameter("user");
    String emailAddr = request.getParameter("email");
    String track = request.getParameter("track");

    if (track.length() < 1) {
      out.println("No tracking number was selected" +
		  "<P>Press the BACK button on your browser to select a " +
		  "tracking number to track your order");
      return;
    }
  
    try
    {
      Connection connection = connPool.getConnection();
      stmt = connection.createStatement();

      sql.append("SELECT status FROM myorder " +
		 "WHERE tracking_no=\"" + track + "\"");
      rs = stmt.executeQuery(sql.toString());
      if (rs.next())
      {
	status = rs.getString(1);
      }

      if (status.compareToIgnoreCase("In Progress") == 0)
      {
        // Delete from mylaptop table
        sql.delete(0, sql.length());
	sql.append("DELETE FROM mylaptop " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());

	// Delete from myworkstation table
	sql.delete(0, sql.length());
	sql.append("DELETE FROM myworkstation " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());

	// Delete from myequipment table
	sql.delete(0, sql.length());
	sql.append("DELETE FROM myequipment " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());

	// Delete from myorder table
	sql.delete(0, sql.length());
	sql.append("DELETE FROM myorder " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());

	// Delete from myequipt table
	sql.delete(0, sql.length());
	sql.append("DELETE FROM myequipt " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());

	createPage(out, track, userName, emailAddr);
      }
      else
      {
	out.println("<HTML>\n" +
		    "<HEAD>\n" +
		    "  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		    "  <TITLE>Can't change order</TITLE>\n" +
		    "</HEAD>\n\n" +
		    "  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		    "VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n");
	out.println("<P>You cannot change your order now because your " +
		    "current order status is <B>" + status + "</B></P>\n" +
		    "<A HREF=\"../jsp/user_menu.jsp?email=" + emailAddr +
		    "\">Click here</A> to go back to main menu.\n");
	out.println("</BODY>\n</HTML>");
      }
    }
    catch(SQLException e)
    {
      response.sendError(response.SC_ACCEPTED, "The request has been " +
			 "accepted, but it failed to complete due to " +
			 "an error querying the database.");
      out.println(e);
      return;
    }

  } // end doPost


  private void createPage(PrintWriter out, String track, String name,
			  String email)
  {
    out.println("<HTML>\n" +
		"<HEAD>\n" +
		"  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		"  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		"VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n" +
		"  <TITLE>Ordered Items</TITLE>\n" +
		"</HEAD>\n"); 

    out.println("<BODY>\n\n" +
		"<FONT SIZE=+2>Your order with tracking number <B>" + track +
		"</B> has been cancelled</FONT>");

    out.println("<BR></BR>");
    out.println("<BR></BR>");

    out.println("|&nbsp;<A HREF=\"http://jsp.csci.unt.edu/chung/" +
		"index.html#Order\">Home</A>&nbsp;|&nbsp;" +
		"<A HREF=\"../jsp/begin_order_form.jsp?email=" + email +
		"\">Order Items</A>&nbsp;|&nbsp;" +
		"<A HREF=\"../jsp/cancel_order.jsp?email=" + email + "\">" +
		"Cancel order</A>&nbsp;|&nbsp;" +
		"<A HREF=\"../jsp/change_order.jsp?email=" + email + "\">" +
		"Change order</A>&nbsp;|\n");

    out.println("</BODY>\n" +
		"</HTML>");

  } // end listOrder

} // end TrackOrder

