import java.util.*;

public class Inventory extends Item implements Invent
{

 private Vector inventory;
 
 public Inventory()
 {
  inventory = new Vector();
  startInventory(); // start the inventory with determine items
 }

 public int getInventorySize()
 {
  return inventory.size();
 }

 public void addInventory(Item newItem)
 {
  inventory.addElement((Object)newItem); //add new Item
 } 

/**
 * getInventory's method to retrieve the Item based on
 * the given the integer number. 
 * @param  int number
 * @return Item
 */
 public Item getInventory(int number)
 {
  return (Item)inventory.elementAt(number);
 }

/**
 * getInventory by String is to get Item with the given
 * typeItem (i.e. hd1, mem1, etc). It tranverses the 
 * whole inventory looking for the type.
 * @param  String typeItem
 * @return Item 
 */
 public Item getInventory(String typeItem)
 {
  Item tempItem;
  String tempType;

  int size = getInventorySize();
  for(int i=0; i<size; i++)
  {
   tempItem = getInventory(i);
   tempType = tempItem.getType();
   if(typeItem.compareTo(tempType) == 0)
     return tempItem;   //return the found item
  }
  
  return NO_SUCH_ITEM; //Item not found
 } 

 public String getItemDesc(String typeItem)
 {
  if(typeItem == null)
    return null;

  Item tempItem = getInventory(typeItem);

  if(tempItem == NO_SUCH_ITEM)
    return null;
  else  
    return tempItem.getDescription(); 
 }

 public int getItemQty(Item queryItem)
 {
   return queryItem.getQuantity();
 }

 public float getItemPrice(Item queryItem)
 {
   return queryItem.getPrice();
 }

 public void removeAllInventory()
 {
  inventory.removeAllElements();
 }

 public void removeInventory(int number)
 {
  inventory.removeElementAt(number);
 }

 public void startInventory()
 {
  String typeItem1 = new String("hd1");
  String typeItem2 = new String("hd2");
  String typeItem3 = new String("mem1");
  String typeItem4 = new String("mem2");
  String typeItem5 = new String("vidcard1");
  String typeItem6 = new String("vidcard2");
  String typeItem7 = new String("keyboard1");
  String typeItem8 = new String("keyboard2");
  String typeItem9 = new String("mouse1");
  String typeItem10 = new String("mouse2");
  String typeItem11 = new String("sndcard1");
  String typeItem12 = new String("sndcard2");
  String typeItem13 = new String("mon1");
  String typeItem14 = new String("mon2");
  String typeItem15 = new String("mon3");
  String typeItem16 = new String("mon4");
  String typeItem17 = new String("mon5");
  String typeItem18 = new String("cdrom1");
  String typeItem19 = new String("cdrw1");
  String typeItem20 = new String("dvdrom1");
  String typeItem21 = new String("fd1");
  String typeItem22 = new String("zip1");
  String typeItem23 = new String("nic1");
  String typeItem24 = new String("nic2");
  String typeItem25 = new String("speaker1");
  String typeItem26 = new String("speaker2");
  String typeItem27 = new String("laptop1");
  String typeItem28 = new String("laptop2");
  String typeItem29 = new String("laptop3");
  String typeItem30 = new String("laptop4");
  String typeItem31 = new String("os1");
  String typeItem32 = new String("os2");

  String descItem1 = 
  new String("Hard Drive:  IBM Deskstar 75GX series 20GB ATA 100");
  String descItem2 = 
  new String("Hard Drive:  Maxtor Diamond series 40GB ATA 66");
  String descItem3 = 
  new String("Memory:  Kingston 64MB SDRAM PC133");
  String descItem4 = 
  new String("Memory:  Kingston 128MB SDRAM PC133");
  String descItem5 = 
  new String("Video Card:  Innovision nVidia GeForce2MX 32MB DDR");
  String descItem6 = 
  new String("Video Card:  Innovision nVidia GeForce2GTS 64MB DDR");
  String descItem7 = 
  new String("Keyboard:  Microsoft Keyboard 104-keys");
  String descItem8 = 
  new String("Keyboard:  Logitech iTouch 104-keys");
  String descItem9 = 
  new String("Mouse:  Microsoft 2 buttons wheel");
  String descItem10 = 
  new String("Mouse:  Microsoft Optical mouse");
  String descItem11 = 
  new String("Sound Card: Creative Lab Live! [OEM]");
  String descItem12 = 
  new String("Sound Card: Creative Lab Platinum 5.1");
  String descItem13 = 
  new String("Monitor: ViewSonic EF70 17\" Flat Screen .25mm");
  String descItem14 = 
  new String("Monitor: ViewSonic E790 19\" .26mm 1600X1200");
  String descItem15 = 
  new String("Monitor: ViewSonic P220F 22\" .25mm 1600X1200");
  String descItem16 = 
  new String("LCD Monitor: Philip Brilliance 150P 15.1\" TFT");
  String descItem17 = 
  new String("LCD Monitor: Syncmaster 170MP 17\" ");
  String descItem18 = 
  new String("CD-ROM: Shuttle 56X EIDE");
  String descItem19 = 
  new String("CD-RW: Sony 8X/4X/32X EIDE");
  String descItem20 = 
  new String("DVD-ROM: Toshiba 16X/48X EIDE");
  String descItem21 = 
  new String("Floopy: Sony 1.44\" Floopy Drive");
  String descItem22 = 
  new String("ZIP: Iomega Zip 100MB INTERNAL EIDE 3.5\"");
  String descItem23 = 
  new String("NIC: Linksys PCI 10/100");
  String descItem24 = 
  new String("NIC: Netgear FA311 10/100 PCI");
  String descItem25 = 
  new String("Speaker: ACS33 AMPL PowerCube 10W-SPK 15W Sub");
  String descItem26 = 
  new String("Speaker: YSTMS201W 3 Piece AMPL-30W SPK White");
  String descItem27 = 
  new String("HP Pavilion N5210 Celeron 650MHz 64MB 10GBHD 24XCD"+
             "13\"display");
  String descItem28 = 
  new String("Toshiba Satellite 2805 Pentium III 700Mhz 128MB 10GB"+
             "8XDVD 14.1\"TFT");
  String descItem29 = 
  new String("Sony VAIO SlimLine Pentium III 750Mhz 64MB 15GB 12.1\"TFT");
  String descItem30 = 
  new String("HP Pavillion Pentium III 1Ghz 256MB 30GB 8XDVD 15\"TFT");
  String descItem31 =
  new String("Microsoft Windows 2000 Pro Upgrade");
  String descItem32 =
  new String("RedHat Linux Pro 7.0");

  Float priceItem1= new Float(103.00);
  Float priceItem2=new Float(129.00);
  Float priceItem3=new Float(45.00);
  Float priceItem4=new Float(78.00);
  Float priceItem5=new Float(109.00);
  Float priceItem6=new Float(176.00);
  Float priceItem7=new Float(29.00);
  Float priceItem8=new Float(15.00);
  Float priceItem9=new Float(34.00);
  Float priceItem10=new Float(40.00);
  Float priceItem11=new Float(29.00);
  Float priceItem12=new Float(171.00);
  Float priceItem13=new Float(274.99);
  Float priceItem14=new Float(320.00);
  Float priceItem15=new Float(829.99);
  Float priceItem16=new Float(720.00);
  Float priceItem17=new Float(1419.99);
  Float priceItem18=new Float(42.99);
  Float priceItem19=new Float(139.99);
  Float priceItem20=new Float(150.00);
  Float priceItem21=new Float(25.00);
  Float priceItem22=new Float(108.00);
  Float priceItem23=new Float(16.00);
  Float priceItem24=new Float(17.00);
  Float priceItem25=new Float(40.00);
  Float priceItem26=new Float(39.00);
  Float priceItem27=new Float(1100.00);
  Float priceItem28=new Float(1799.00);
  Float priceItem29=new Float(2500.00);
  Float priceItem30=new Float(3000.00);
  Float priceItem31=new Float(115.00);
  Float priceItem32=new Float(55.00);

  Item item1 = new Item(typeItem1,descItem1,priceItem1.floatValue());
  Item item2 = new Item(typeItem2,descItem2,priceItem2.floatValue());
  Item item3 = new Item(typeItem3,descItem3,priceItem3.floatValue());
  Item item4 = new Item(typeItem4,descItem4,priceItem4.floatValue());
  Item item5 = new Item(typeItem5,descItem5,priceItem5.floatValue());
  Item item6 = new Item(typeItem6,descItem6,priceItem6.floatValue());
  Item item7 = new Item(typeItem7,descItem7,priceItem7.floatValue());
  Item item8 = new Item(typeItem8,descItem8,priceItem8.floatValue());
  Item item9 = new Item(typeItem9,descItem9,priceItem9.floatValue());
  Item item10 = new Item(typeItem10,descItem10,priceItem10.floatValue());
  Item item11 = new Item(typeItem11,descItem11,priceItem11.floatValue());
  Item item12 = new Item(typeItem12,descItem12,priceItem12.floatValue());
  Item item13 = new Item(typeItem13,descItem13,priceItem13.floatValue());  
  Item item14 = new Item(typeItem14,descItem14,priceItem14.floatValue());
  Item item15 = new Item(typeItem15,descItem15,priceItem15.floatValue());
  Item item16 = new Item(typeItem16,descItem16,priceItem16.floatValue());
  Item item17 = new Item(typeItem17,descItem17,priceItem17.floatValue());
  Item item18 = new Item(typeItem18,descItem18,priceItem18.floatValue());
  Item item19 = new Item(typeItem19,descItem19,priceItem19.floatValue());
  Item item20 = new Item(typeItem20,descItem20,priceItem20.floatValue());
  Item item21 = new Item(typeItem21,descItem21,priceItem21.floatValue());
  Item item22 = new Item(typeItem22,descItem22,priceItem22.floatValue());
  Item item23 = new Item(typeItem23,descItem23,priceItem23.floatValue());
  Item item24 = new Item(typeItem24,descItem24,priceItem24.floatValue());
  Item item25 = new Item(typeItem25,descItem25,priceItem25.floatValue());
  Item item26 = new Item(typeItem26,descItem26,priceItem26.floatValue());
  Item item27 = new Item(typeItem27,descItem27,priceItem27.floatValue());
  Item item28 = new Item(typeItem28,descItem28,priceItem28.floatValue());
  Item item29 = new Item(typeItem29,descItem29,priceItem29.floatValue());
  Item item30 = new Item(typeItem30,descItem30,priceItem30.floatValue());
  Item item31 = new Item(typeItem31,descItem31,priceItem31.floatValue());
  Item item32 = new Item(typeItem32,descItem32,priceItem32.floatValue());

  addInventory(item1);
  addInventory(item2);
  addInventory(item3);
  addInventory(item4);
  addInventory(item5);
  addInventory(item6);
  addInventory(item7);
  addInventory(item8);
  addInventory(item9);
  addInventory(item10);
  addInventory(item11);
  addInventory(item12);
  addInventory(item13);
  addInventory(item14);
  addInventory(item15);
  addInventory(item16);
  addInventory(item17);
  addInventory(item18);
  addInventory(item19);
  addInventory(item20);
  addInventory(item21);
  addInventory(item22);
  addInventory(item23);
  addInventory(item24);
  addInventory(item25);
  addInventory(item26);
  addInventory(item27);
  addInventory(item28);
  addInventory(item29);
  addInventory(item30);
  addInventory(item31);
  addInventory(item32);

    
 }
}
