
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ListTrackNo extends HttpServlet {

  private ConnectionPool connPool;
  private int MAXSIZE=512;

  protected int initialConnection() {
    return(10);
  }

  protected int maxConnections() {
    return(50);
  }

  public void init() throws ServletException {
    String driver="org.gjt.mm.mysql.Driver";
    String url="jdbc:mysql://richese.csci.unt.edu/chung";
    String user="chung";
    String pwd="chung";

    try {
      connPool=new ConnectionPool(driver, url, user, pwd, initialConnection(),
				  maxConnections(), true); 
    } catch(SQLException sqle) {
      System.err.println("Error making pool:"+sqle);
      getServletContext().log("Error making pool:"+sqle);
      connPool = null;   
    }
  }

  public void destroy() {
    connPool.closeAllConnections();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    doPost(request,response);
  } 

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    ResultSet rs;
    Statement stmt;
    PrintWriter out = response.getWriter();
    StringBuffer sql = new StringBuffer(MAXSIZE);
    StringBuffer tempOrder = new StringBuffer(MAXSIZE);
    Vector track = new Vector();
    boolean admin = true;
    String type = new String("");
    String password = new String("");
    String userName = new String();
    String temp = new String();

    response.setContentType("text/html");

    Enumeration pNames = request.getParameterNames();
    String emailAddr = request.getParameter("email");

    String trackNotFoundURL = "http://jsp.csci.unt.edu/chung/jsp/";

    while (pNames.hasMoreElements())
    {
      temp = (String) pNames.nextElement();
      if (temp.compareToIgnoreCase("user") == 0 || temp.startsWith("password"))
	admin = false;
    }

    if (!admin)
    {
      if (request.getParameter("password_cancel") != null)
      {
	type = "password_cancel";
      }
      else if (request.getParameter("password_change") != null)
      {
	type = "password_change";
      }
      else if (request.getParameter("password_track") != null)
      {
	type = "password_track";
      }

      password = request.getParameter(type);
      userName = request.getParameter("user");
    }

    if(!admin && password != null && password.length() < 1)
    {
      out.println("<P>Need to input password</P>\n");
      out.println("<p>Press the BACK botton on your browser and" +
                " re-enter the missing fields or reconfirm the password</p>");
      return;
    }

    try
    {
      Connection connection = connPool.getConnection();
      stmt = connection.createStatement();   

      sql.append("SELECT email, password FROM myuser WHERE email=\"" +
		 emailAddr + "\"");
      rs = stmt.executeQuery(sql.toString());

      // check if email was entered
      if (admin && !rs.next())
      {
	String copyEmail = emailAddr;

	// check email validition
	if (emailAddr.indexOf('@') == -1)
	{
	  out.println("<P>Invalid email address</P>\n");
	  out.println("<p>Press the BACK botton on your browser and" +
		      " re-enter the custumer's e-mail</p>");
	  return;
	}
	else if ((copyEmail.substring(copyEmail.indexOf('@'))).indexOf('.')
		 == -1)
	{
	  out.println("<P>Invalid email address</P>\n");
	  out.println("<p>Press the BACK botton on your browser and" +
		      " re-enter the custumer's e-mail</p>");
	  return;
	}
	else {
	  out.println("<P>Email not found");
	  out.println("<p>Press the BACK botton on your browser and" +
		      " re-enter the custumer's e-mail</p>");
	  return;
	}
      }

      if (!admin)
      {
	if (rs.next())
	{
	  if (password != null && (rs.getString(2)).compareTo(password) != 0)
	  {
	    //user must have registered since the name and email are found
            //in the database. Even the password is matched.
	      out.println("<P>Password verification failed.\n" +
			  "<P>Please press BACK button on your broswer to " +
			  "re-enter your password\n");
	      return;
	  }
	} // end of while-loop
	else
	{
	  out.println("<P>Email not found");
	  return;
	}
      } // end if (!admin)

      sql.delete(0, sql.length());
      sql.append("SELECT tracking_no FROM myorder WHERE email=\"" +
		 emailAddr + "\"");
      rs = stmt.executeQuery(sql.toString());

      while (rs.next())
      {
	if (rs.getInt(1) > 0)
	  track.add(rs.getString(1));
      }

      if (track.size() == 0)
      {
	if (admin)
	  trackNotFoundURL += "admin_track_not_found.jsp";
	else
	  trackNotFoundURL += "track_not_found.jsp?email=" + emailAddr;

	response.sendRedirect(response.encodeURL(trackNotFoundURL));
      }
      else
        listTrackNum(out, track, userName, emailAddr, type, admin);
    }
    catch(SQLException e)
    {
      response.sendError(response.SC_ACCEPTED, "The request has been " +
			 "accepted, but it failed to complete due to " +
			 "an error querying the database.");
      out.println(e);
      return;
    }
  } // end of doPost's method


  private void listTrackNum(PrintWriter out, Vector track, String name,
			    String email, String type, boolean admin)
    throws ArrayIndexOutOfBoundsException
  {
    int i;
    int size = track.size();

    out.println("<HTML>\n" +
		"<HEAD>\n" +
		"  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		"  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		"VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n" +
		"  <TITLE>Tracking Number(s)</TITLE>\n" +
		"</HEAD>\n"); 

    if (admin)
    {
      out.println("<BODY>\n\n" +
		  "<FONT SIZE=+2>" +
		  "Choose a tracking number to change the order status" +
		  "</FONT><P>\n"+
		  "<FORM METHOD=\"POST\" ACTION=\"ListStatus\">\n");
    }
    else
    {
      if (type.compareToIgnoreCase("password_cancel") == 0)
      {
        out.println("<BODY>\n\n" +
		    "<H1>Choose a tracking number to cancel your order</H1>" +
		    "<P>\n"+
		    "<FORM METHOD=\"POST\" ACTION=\"CancelOrder\">\n");
      }
      else if (type.compareToIgnoreCase("password_change") == 0)
      {
        out.println("<BODY>\n\n" +
		    "<H1>Choose a tracking number to change your order</H1>" +
		    "<P>\n"+
		    "<FORM METHOD=\"POST\" ACTION=\"ListChangeOrder\">\n");
      }
      else //if (type.compareToIgnoreCase("password_track") == 0)
      {
        out.println("<BODY>\n\n" +
		    "<H1>Choose a tracking number to track your order</H1>" +
		    "<P>\n"+
		    "<FORM METHOD=\"POST\" ACTION=\"TrackOrder\">\n");
      }
    }

    out.println("<TABLE>\n" +
		"<TR>");

    for (i = 0 ; i < size; i++)
    {
      out.println("  <TD><INPUT TYPE=\"RADIO\" NAME=\"track\"" +
		  " VALUE=\"" + (String) track.get(i) + "\"></TD>\n" +
		  "  <TD>" + (String) track.get(i) + "</TD>\n" +
		  "</TR><TR>");
    }

    out.println("</TR>\n" +
		"</TABLE>\n");
    out.println("<TABLE>");
    out.println("<TR HEIGHT=25>");

    if (admin)
    {
      out.println("  <TD><INPUT TYPE=\"SUBMIT\" VALUE=\"Change\"></TD>");
      out.println("</TR><TR HEIGHT=100>" +
		  "  <TD>|&nbsp;" +
		  "<A HREF=\"http://jsp.csci.unt.edu/chung/" +
		  "index.html#Order\">Home</A>" +
		  "&nbsp;\n|&nbsp;" +
		  "<A HREF=\"list_tracks.jsp\">List Tracking Numbers</A>\n" +
		  "&nbsp;|</TD>");
    }
    else
    {
      out.println("  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"email\" " +
		  "VALUE=\"" + email + "\"></TD>");
      out.println("</TR><TR>\n" +
		  "  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"user\" " +
		  "VALUE=\"" + name + "\"></TD>");
      out.println("</TR><TR HEIGHT=0>");

      if (type.compareToIgnoreCase("password_cancel") == 0)
      {
        out.println("  <TD><INPUT TYPE=\"SUBMIT\" VALUE=\"Cancel\"></TD>");
      }
      else if (type.compareToIgnoreCase("password_change") == 0)
      {
        out.println("  <TD><INPUT TYPE=\"SUBMIT\" VALUE=\"Change\"></TD>");
      }
      else //if (type.compareToIgnoreCase("password_track") == 0)
      {
        out.println("  <TD><INPUT TYPE=\"SUBMIT\" VALUE=\"Track\"></TD>");
      }

      out.println("</TR><TR HEIGHT=200>\n" +
		  "  <TD>|&nbsp;" +
		  "<A HREF=\"http://jsp.csci.unt.edu/chung/" +
		  "index.html#Order\">Home</A>" +
		  "&nbsp;\n|&nbsp;" +
		  "<A HREF=\"../jsp/begin_order_form.jsp?email=" + email +
		  "\">Order Items</A>&nbsp;|&nbsp;");

      if (type.compareToIgnoreCase("password_cancel") == 0)
      {
        out.println("<A HREF=\"../jsp/change_order.jsp?email=" + email +
		    "\">Change order</A>&nbsp;\n|&nbsp;" +
		    "<A HREF=\"../jsp/track_order.jsp?email=" + email +
		    "\">Track order</A>&nbsp;|</TD>");
      }
      else if (type.compareToIgnoreCase("password_change") == 0)
      {
        out.println("<A HREF=\"../jsp/cancel_order.jsp?email=" + email +
		    "\">Cancel order</A>&nbsp;\n|&nbsp;" +
		    "<A HREF=\"../jsp/track_order.jsp?email=" + email +
		    "\">Track order</A>&nbsp;|</TD>");
      }
      else //if (type.compareToIgnoreCase("password_track") == 0)
      {
        out.println("<A HREF=\"../jsp/cancel_order.jsp?email=" + email +
		    "\">Cancel order</A>&nbsp;\n|&nbsp;" +
		    "<A HREF=\"../jsp/change_order.jsp?email=" + email +
		    "\">Change order</A>&nbsp;|</TD>");
      }
    }

    out.println("</TR>\n" +
		"</TABLE>\n" +
		"</FORM>\n\n" +
		"</BODY>\n" +
		"</HTML>");
  } // end listTrackNum
} // end of CreateProfile.java


