
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ChangeStatus extends HttpServlet {

  private ConnectionPool connPool;
  private int MAXSIZE=512;

  protected int initialConnection() {
    return(10);
  }

  protected int maxConnections() {
    return(50);
  }

  public void init() throws ServletException {
    String driver="org.gjt.mm.mysql.Driver";
    String url="jdbc:mysql://richese.csci.unt.edu/chung";
    String user="chung";
    String pwd="chung";

    try {
      connPool=new ConnectionPool(driver, url, user, pwd, initialConnection(),
				  maxConnections(), true); 
    } catch(SQLException sqle) {
      System.err.println("Error making pool:"+sqle);
      getServletContext().log("Error making pool:"+sqle);
      connPool = null;   
    }
  }

  public void destroy() {
    connPool.closeAllConnections();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    doPost(request,response);
  } 

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {

    ResultSet rs;
    Statement stmt;
    PrintWriter out = response.getWriter();
    StringBuffer sql = new StringBuffer(MAXSIZE);

    response.setContentType("text/html");

    String track = request.getParameter("track");
    String status = request.getParameter("status");

    if (track.length() < 1) {
      out.println("No tracking number was selected" +
		  "<P>Press the BACK button on your browser to select a " +
		  "tracking number to track your order");
      return;
    }
  
    try
    {
      Connection connection = connPool.getConnection();
      stmt = connection.createStatement();

      // Update status from myoder table
      sql.append("UPDATE myorder " +
		 "SET status=\"" + status + "\" " +
		 "WHERE tracking_no=\"" + track + "\"");
      stmt.executeUpdate(sql.toString());

      createPage(out, track, status);
    }
    catch(SQLException e)
    {
      response.sendError(response.SC_ACCEPTED, "The request has been " +
			 "accepted, but it failed to complete due to " +
			 "an error querying the database.");
      out.println(e);
      return;
    }

  } // end doPost


  private void createPage(PrintWriter out, String track, String status)
  {
    out.println("<HTML>\n" +
		"<HEAD>\n" +
		"  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		"  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		"VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n" +
		"  <TITLE>Status changed confirmation</TITLE>\n" +
		"</HEAD>\n"); 

    out.println("<BODY>\n\n" +
		"The status of the order with tracking number <B>" + track +
		"</B> has been changed to <B>" + status + "</B>.");

    out.println("<BR></BR>\n" +
		"<BR></BR>\n");

    out.println("|&nbsp;\n" +
		"<A HREF=\"http://jsp.csci.unt.edu/chung/index.html#Order\">" +
		"Home</A>" +
		"&nbsp;|&nbsp;\n" +
		"<A HREF=\"../jsp/list_tracks.jsp\">List Tracking Numbers</A>"+
		"&nbsp;|&nbsp;\n" +
		"<A HREF=\"../jsp/change_status.jsp\">Change Status</A>" +
		"&nbsp;|");

    out.println("</BODY>\n" +
		"</HTML>");

  } // end listOrder

} // end TrackOrder

