
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ListChangeOrder extends HttpServlet {

  private ConnectionPool connPool;
  private int MAXSIZE=512;

  protected int initialConnection() {
    return(10);
  }

  protected int maxConnections() {
    return(50);
  }

  public void init() throws ServletException {
    String driver="org.gjt.mm.mysql.Driver";
    String url="jdbc:mysql://richese.csci.unt.edu/chung";
    String user="chung";
    String pwd="chung";

    try {
      connPool=new ConnectionPool(driver, url, user, pwd, initialConnection(),
				  maxConnections(), true); 
    } catch(SQLException sqle) {
      System.err.println("Error making pool:"+sqle);
      getServletContext().log("Error making pool:"+sqle);
      connPool = null;   
    }
  }

  public void destroy() {
    connPool.closeAllConnections();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    doPost(request,response);
  } 

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    ResultSet rs;
    Statement stmt;
    PrintWriter out = response.getWriter();
    StringBuffer sql = new StringBuffer(MAXSIZE);
    Vector workstation = new Vector();
    Vector laptop = new Vector();
    Vector equipment = new Vector();
    Vector order = new Vector();
    String type = new String("");

    //String nextURL = "http://jsp.csci.unt.edu/chung/user_menu.jsp";
    //String encodedURL = response.encodeURL(nextURL);

    response.setContentType("text/html");

    String userName = request.getParameter("user");
    String emailAddr = request.getParameter("email");
    String track = request.getParameter("track");

    if (track.length() < 1) {
      out.println("No tracking number was selected" +
		  "<P>Press the BACK button on your browser to select a " +
		  "tracking number to track your order");
      return;
    }
  
    try
    {
      Connection connection = connPool.getConnection();
      stmt = connection.createStatement();   

      // Query from mylaptop table
      sql.append("SELECT model, qty FROM mylaptop " +
		 "WHERE tracking_no=\"" + track + "\"");
      rs = stmt.executeQuery(sql.toString());
      if (rs.next())
      {
	laptop.add(rs.getString(1));
	laptop.add(new Integer(rs.getInt(2)));
	type = "laptop";
      }
      else
      {
        // Query from myworkstation table
	sql.delete(0, sql.length());
	sql.append("SELECT model, qty FROM myworkstation " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());
	if (rs.next())
	{
	  workstation.add(rs.getString(1));
	  workstation.add(new Integer(rs.getInt(2)));
	  type = "workstation";
	}

	// Query from myequipment table
	sql.delete(0, sql.length());
	sql.append("SELECT * FROM myequipment " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());
	if (rs.next())
        {
	  equipment.add(rs.getString(2));
	  equipment.add(new Integer(rs.getInt(3)));
	  equipment.add(rs.getString(6));
	  equipment.add(new Integer(rs.getInt(7)));
	  equipment.add(rs.getString(14));
	  equipment.add(new Integer(rs.getInt(15)));
	  equipment.add(rs.getString(12));
	  equipment.add(new Integer(rs.getInt(13)));
	  equipment.add(rs.getString(10));
	  equipment.add(new Integer(rs.getInt(11)));
	  equipment.add(rs.getString(16));
	  equipment.add(new Integer(rs.getInt(17)));
	  equipment.add(rs.getString(30));
	  equipment.add(new Integer(rs.getInt(31)));
	  equipment.add(rs.getString(18));
	  equipment.add(new Integer(rs.getInt(19)));
	  equipment.add(rs.getString(20));
	  equipment.add(new Integer(rs.getInt(21)));
	  equipment.add(rs.getString(22));
	  equipment.add(new Integer(rs.getInt(23)));
	  equipment.add(rs.getString(4));
	  equipment.add(new Integer(rs.getInt(5)));
	  equipment.add(rs.getString(24));
	  equipment.add(new Integer(rs.getInt(25)));
	  equipment.add(rs.getString(8));
	  equipment.add(new Integer(rs.getInt(9)));
	  equipment.add(rs.getString(26));
	  equipment.add(new Integer(rs.getInt(27)));
	  equipment.add(rs.getString(28));
	  equipment.add(new Integer(rs.getInt(29)));

	  if (type.length() == 0)
	    type = "equipment";
	}
      } // end else

      // Query from myorder table
      sql.delete(0, sql.length());
      sql.append("SELECT status, order_date, price FROM myorder " +
		 "WHERE tracking_no=\"" + track + "\"");
      rs = stmt.executeQuery(sql.toString());
      if (rs.next())
      {
	order.add(rs.getString(1));
	order.add(rs.getDate(2));
	order.add(new Float(rs.getFloat(3)));
      }

      // List ordered items to web browser
      listOrder(out, workstation, laptop, equipment, order, track,
		userName, emailAddr);

    }
    catch(SQLException e)
    {
      response.sendError(response.SC_ACCEPTED, "The request has been " +
			 "accepted, but it failed to complete due to " +
			 "an error querying the database.");
      out.println(e);
      return;
    }
  
  } // end doPost


  private void listOrder(PrintWriter out, Vector workstation, Vector laptop,
			 Vector equipment, Vector order, String track,
			 String name, String email)
  {
    int size;
    float price;
    String itemTypeDB = new String();
    String itemType = new String();
    Inventory item = new Inventory();
    boolean change = false;

    out.println("<HTML>\n" +
		"<HEAD>\n" +
		"  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		"  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		"VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n" +
		"  <TITLE>Change Order</TITLE>\n" +
		"</HEAD>\n"); 

    if (((String) order.get(0)).compareToIgnoreCase("In Progress") != 0)
    {
      out.println("<FONT COLOR=\"RED\" SIZE=+2>You cannot change your " +
		  "order when the order status is <B>" +
		  (String) order.get(0) + "</B>.</FONT></TD>");

      out.println("<BR></BR>\n<BR></BR>");

      out.println("|&nbsp;" +
		  "<A HREF=\"http://jsp.csci.unt.edu/chung/" +
		  "index.html#Order\">Home</A>&nbsp;|&nbsp;" +
		  "<A HREF=\"../jsp/begin_order_form.jsp?email=" + email +
		  "\">Order Items</A>&nbsp;|&nbsp;" +
		  "<A HREF=\"../jsp/cancel_order.jsp?email=" + email + "\">" +
		  "Cancel order</A>&nbsp;|&nbsp;" +
		  "<A HREF=\"../jsp/change_order.jsp?email=" + email + "\">" +
		  "Change order</A>&nbsp;|&nbsp;" +
		  "<A HREF=\"../jsp/track_order.jsp?email=" + email + "\">" +
		  "Track order</A>&nbsp;|");

      out.println("</BODY>\n" +
		  "</HTML>");

      return;
    }

    out.println("<BODY>\n\n" +
		"<FONT FACE=ARIAL SIZE=+3><B>Change Order Form for " + name +
		"</B></FONT>\n<P>" +
		"Following listed your ordered items with tracking number <B>"+
		track + "</B>");

    out.println("<BR></BR>\n<BR></BR>");

    out.println("\n<FORM METHOD=\"POST\" ACTION=\"ChangeOrder\">\n");

    out.println("<TABLE BORDER=1 CELLSPACING=2 CELLPADDING=2 WIDTH=75%>\n" +
		"<TR>");

    out.println("  <TD COLSPAN=4 ALIGN=CENTER><FONT FACE=ARIAL SIZE=+2>" +
		"<STRONG>Available Items</STRING></FONT></TD>" +
		"</TR><TR>");

    out.println("  <TD ALIGN=CENTER><B>No.</B></TD>\n" +
		"  <TD ALIGN=CENTER><B>Item Description</B></TD>\n" +
		"  <TD ALIGN=CENTER><B>Unit Price (US$)</B></TD>\n" +
		"  <TD ALIGN=CENTER><B>Qty</B></TD>\n" +
		"</TR><TR>");

    if ((size = laptop.size()) > 0)
    {
      itemTypeDB = (String) laptop.get(0);
      for (int i = 1; i <= 4; i++)
      {
	itemType = "laptop" + String.valueOf(i);
        price = item.getItemPrice(item.getInventory(itemType));
	out.println("  <TD>" + i + "</TD>\n" +
		    "  <TD>" + item.getItemDesc(itemType) +
		    "</TD>\n" +
		    "  <TD ALIGN=RIGHT>" + price + "</TD>");

	if (itemTypeDB.compareToIgnoreCase(itemType) == 0)
	{
	  out.println("  <TD><INPUT TYPE=TEXT NAME=" + itemType + " VALUE=" +
		      ((Integer) laptop.get(1)).intValue() + " SIZE=3>" +
		      "</TD>\n" +
		      "</TR><TR>");
	}
	else
	{
	  out.println("  <TD><INPUT TYPE=TEXT NAME=" + itemType + " SIZE=3>" +
		      "</TD>\n" +
		      "</TR><TR>");
	}
      } // end for loop

      out.println("  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"option\" " +
		  "VALUE=\"2\"></TD>");

      out.println("</TR>\n" +
		  "</TABLE>\n");
    } // end if ((size = laptop.size()) > 0)
    else
    {
      // for equipment
      if ((size = equipment.size()) > 0)
      {
	int i = 1;
	// 1-12
	for ( ; i <= 12 ; i++)
	{
	  if ((i % 2) == 1)
	    itemTypeDB = (String) equipment.get(i-1);
	  createForm(out, itemTypeDB, item, equipment, i, i);
	}

	// 13-17
	itemTypeDB = (String) equipment.get(i-1);
	for ( ; i <= 17; i++)
	{
	  createForm(out, itemTypeDB, item, equipment, i, i);
	}
	
	// 18-22
	for ( ; i <= 22; i++)
	{
	  if (i == 18)
	  {
	    itemTypeDB = (String) equipment.get(i-4);
	    createForm(out, itemTypeDB, item, equipment, i, i-3);
	  }
	  else if (i == 19)
	  {
	    itemTypeDB = (String) equipment.get(i-3);
	    createForm(out, itemTypeDB, item, equipment, i, i-2);
	  }
	  else if (i == 20)
	  {
	    itemTypeDB = (String) equipment.get(i-2);
	    createForm(out, itemTypeDB, item, equipment, i, i-1);
	  }
	  else if (i == 21)
	  {
	    itemTypeDB = (String) equipment.get(i-1);
	    createForm(out, itemTypeDB, item, equipment, i, i);
	  }
	  else if (i == 22)
	  {
	    itemTypeDB = (String) equipment.get(i);
	    createForm(out, itemTypeDB, item, equipment, i, i+1);
	  }
	}

	// 23-26
	for ( ; i <= 26; i++)
	{
	  if ((i % 2) == 1)
	    itemTypeDB = (String) equipment.get(i+1);
	  createForm(out, itemTypeDB, item, equipment, i, i+2);
	}

	// 31-32
	for (i = 31 ; i <= 32; i++)
	{
	  if ((i % 2) == 1)
	    itemTypeDB = (String) equipment.get(i-3);
	  createForm(out, itemTypeDB, item, equipment, i, i-2);
	}

	if (workstation.size() < 1)
	  out.println("  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"option\" " +
		      "VALUE=\"3\"></TD>");

	out.println("</TR>\n" +
		    "</TABLE>\n");

      } // if ((size = equipment.size()) > 0)

      // for workstation
      if ((size = workstation.size()) > 0)
      {
	itemTypeDB = (String) workstation.get(0);
	out.println("<BR></BR>");
	out.println("<TABLE>");
	out.println("<TR>");
	out.println("  <TD>Number of " + itemTypeDB + ":</TD>" +
		    "  <TD><INPUT TYPE=TEXT NAME=workstation VALUE=" +
		    workstation.get(1) + " SIZE=3></TD>");
	out.println("</TR><TR>");
	out.println("  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"option\" " +
		    "VALUE=\"1\"></TD>");
	out.println("</TR><TR>");
	out.println("  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"cpu\" " +
		    "VALUE=\"" + itemTypeDB + "\"></TD>");
	out.println("</TR>");
	out.println("</TABLE>\n");

      }
    } // end outer else of "if ((size = laptop.size()) > 0)"

    out.println("<TABLE>");
    out.println("<TR>");
    out.println("  <TD>Total Amount: US$" + (Float) order.get(2) + "</TD>\n" +
		"</TR><TR>");
    out.println("  <TD>Order Date: " + order.get(1) + "</TD>\n" +
		"</TR><TR>");
    out.println("  <TD>Order Status: " + order.get(0) + "</TD>\n" +
		"</TR><TR>");

    out.println("  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"email\" " +
		"VALUE=\"" + email + "\"></TD>");
    out.println("</TR><TR>\n" +
		"  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"user\" " +
		"VALUE=\"" + name + "\"></TD>");
    out.println("</TR><TR>\n" +
		"  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"track\" " +
		"VALUE=\"" + track + "\"></TD>");

    out.println("</TR><TR HEIGHT=50>\n" +
		"  <TD><INPUT TYPE=\"SUBMIT\" VALUE=\"Change\">" +
		"</TD>");

    out.println("</TR><TR HEIGHT=50>\n" +
		"  <TD>|&nbsp;" +
		"<A HREF=\"http://jsp.csci.unt.edu/chung/" +
		"index.html#Order\">Home</A>&nbsp;|&nbsp;" +
		"<A HREF=\"../jsp/begin_order_form.jsp?email=" + email +
		"\">Order Items</A>&nbsp;|&nbsp;" +
		"<A HREF=\"../jsp/cancel_order.jsp?email=" + email + "\">" +
		"Cancel order</A>&nbsp;|&nbsp;" +
		"<A HREF=\"../jsp/track_order.jsp?email=" + email + "\">" +
		"Track order</A>&nbsp;|</TD>");

    out.println("</TR>\n" +
		"</TABLE>\n" +
		"</FORM>\n\n" +
		"</BODY>\n" +
		"</HTML>");

  } // end listOrder


  // create form for equipment
  private void createForm(PrintWriter out, String itemTypeDB, Inventory item,
			  Vector equipment, int i, int j)
  {
    String itemType = (item.getInventory(i-1)).getType();
    float price = item.getItemPrice(item.getInventory(itemType));
    out.println("  <TD>" + i + "</TD>\n" +
		"  <TD>" + item.getItemDesc(itemType) +
		"</TD>\n" +
		"  <TD ALIGN=RIGHT>" + price + "</TD>");

    if (itemTypeDB.compareToIgnoreCase(itemType) == 0)
    {
      out.println("  <TD><INPUT TYPE=TEXT NAME=" + itemType + " VALUE=" +
		  ((Integer) equipment.get(j)).intValue() + " SIZE=3>" +
		  "</TD>\n" +
		  "</TR><TR>");
    }
    else
    {
      out.println("  <TD><INPUT TYPE=TEXT NAME=" + itemType +
		  " SIZE=3></TD>\n" +
		  "</TR><TR>");
    }
  }
} // end TrackOrder
