
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ListStatus extends HttpServlet {

  private ConnectionPool connPool;
  private int MAXSIZE=512;

  protected int initialConnection() {
    return(10);
  }

  protected int maxConnections() {
    return(50);
  }

  public void init() throws ServletException {
    String driver="org.gjt.mm.mysql.Driver";
    String url="jdbc:mysql://richese.csci.unt.edu/chung";
    String user="chung";
    String pwd="chung";

    try {
      connPool=new ConnectionPool(driver, url, user, pwd, initialConnection(),
				  maxConnections(), true); 
    } catch(SQLException sqle) {
      System.err.println("Error making pool:"+sqle);
      getServletContext().log("Error making pool:"+sqle);
      connPool = null;   
    }
  }

  public void destroy() {
    connPool.closeAllConnections();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    doPost(request,response);
  } 

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
  {
    ResultSet rs;
    Statement stmt;
    String status = new String();
    PrintWriter out = response.getWriter();
    StringBuffer sql = new StringBuffer(MAXSIZE);

    response.setContentType("text/html");

    String copyTrack = request.getParameter("track");

    if (copyTrack.length() < 1) {
      out.println("No tracking number was selected" +
		  "<P>Press the BACK button on your browser to select a " +
		  "tracking number to track your order");
      return;
    }

    int track = (Integer.valueOf(copyTrack)).intValue();
  
    try
    {
      Connection connection = connPool.getConnection();
      stmt = connection.createStatement();   

      // Query from myorder table
      sql.append("SELECT status FROM myorder " +
		 "WHERE tracking_no=" + track);
      rs = stmt.executeQuery(sql.toString());
      if (rs.next())
      {
        status = rs.getString(1);
      }

      // Create order status form to web browser so the
      //   system admin can change it
      createStatusForm(out, status, track);
    }
    catch(SQLException e)
    {
      response.sendError(response.SC_ACCEPTED, "The request has been " +
			 "accepted, but it failed to complete due to " +
			 "an error querying the database.");
      out.println(e);
      return;
    }

  }// end doPost


  private void createStatusForm(PrintWriter out, String status, int track)
  {
    String selected_inp = new String("");
    String selected_sub = new String("");
    String selected_rec = new String("");

    if (status.compareToIgnoreCase("In Progress") == 0)
      selected_inp = "SELECTED";
    else if (status.compareToIgnoreCase("Submitted") == 0)
      selected_sub = "SELECTED";
    else if (status.compareToIgnoreCase("Received") == 0)
      selected_rec = "SELECTED";

    out.println("<HTML>\n" +
		"<HEAD>\n" +
		"  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		"  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		"VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n" +
		"  <TITLE>Change order status</TITLE>\n" +
		"</HEAD>\n"); 

    out.println("<BODY>\n\n" +
		"Following is the current order status of the order with " +
		"tracking number <B>" + track + "</B>");

    out.println("<P>Select a new status to change the order status</P>");
    out.println("\n<FORM METHOD=\"POST\" ACTION=\"ChangeStatus\">\n");

    out.println("<TABLE>");
    out.println("<TR>");
    out.println("  <TD>Order Status:</TD>\n" +
		"  <TD><SELECT NAME=\"status\">\n" +
		"        <OPTION VALUE=\"In Progress\" " + selected_inp + ">" +
		"In Progress</OPTION>\n" +
		"        <OPTION VALUE=\"Submitted\" " + selected_sub + ">" +
		"Submitted</OPTION>\n" +
		"        <OPTION VALUE=\"Received\" " + selected_rec + ">" +
		"Received</OPTION>\n" +
		"      </SELECT></TD>");

    out.println("</TR><TR>\n" +
		"  <TD><INPUT TYPE=HIDDEN NAME=\"track\" VALUE=\"" + track +
		"\"></TD>");

    out.println("</TR><TR HEIGHT=50>\n" +
		"  <TD COLSPAN=2><INPUT TYPE=\"SUBMIT\" VALUE=\"Change\">" +
		"</TD>");

    out.println("</TR><TR HEIGHT=100>\n" +
		"  <TD COLSPAN=2>|&nbsp;\n" +
		"<A HREF=\"http://jsp.csci.unt.edu/chung/index.html#Order\">" +
		"Home</A>&nbsp;|&nbsp;\n" +
		"<A HREF=\"../jsp/list_tracks.jsp\">List Tracking Numbers</A>"+
		"&nbsp;|</TD>");

    out.println("</TR>\n" +
		"</TABLE>\n" +
		"</FORM>\n");

    out.println("</BODY>\n" +
		"</HTML>");

  } // end listOrder

} // end TrackOrder
