
import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class TrackOrder extends HttpServlet {

  private ConnectionPool connPool;
  private int MAXSIZE=512;

  protected int initialConnection() {
    return(10);
  }

  protected int maxConnections() {
    return(50);
  }

  public void init() throws ServletException {
    String driver="org.gjt.mm.mysql.Driver";
    String url="jdbc:mysql://richese.csci.unt.edu/chung";
    String user="chung";
    String pwd="chung";

    try {
      connPool=new ConnectionPool(driver, url, user, pwd, initialConnection(),
				  maxConnections(), true); 
    } catch(SQLException sqle) {
      System.err.println("Error making pool:"+sqle);
      getServletContext().log("Error making pool:"+sqle);
      connPool = null;   
    }
  }

  public void destroy() {
    connPool.closeAllConnections();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    doPost(request,response);
  } 

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    ResultSet rs;
    Statement stmt;
    PrintWriter out = response.getWriter();
    StringBuffer sql = new StringBuffer(MAXSIZE);
    Vector workstation = new Vector();
    Vector laptop = new Vector();
    Vector equipment = new Vector();
    Vector order = new Vector();

    //String nextURL = "http://jsp.csci.unt.edu/chung/user_menu.jsp";
    //String encodedURL = response.encodeURL(nextURL);

    response.setContentType("text/html");

    String userName = request.getParameter("user");
    String emailAddr = request.getParameter("email");
    String track = request.getParameter("track");

    if (track == null || track.length() < 1) {
      out.println("No tracking number was selected" +
		  "<P>Press the BACK button on your browser to select a " +
		  "tracking number to track your order");
      return;
    }
  
    try
    {
      Connection connection = connPool.getConnection();
      stmt = connection.createStatement();   

      // Query from mylaptop table
      sql.append("SELECT model, qty FROM mylaptop " +
		 "WHERE tracking_no=\"" + track + "\"");
      rs = stmt.executeQuery(sql.toString());
      if (rs.next())
      {
	laptop.add(rs.getString(1));
	laptop.add(new Integer(rs.getInt(2)));
      }
      else
      {
        // Query from myworkstation table
	sql.delete(0, sql.length());
	sql.append("SELECT model, qty FROM myworkstation " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());
	if (rs.next())
	{
	  workstation.add(rs.getString(1));
	  workstation.add(new Integer(rs.getInt(2)));
	}

	// Query from myequipment table
	sql.delete(0, sql.length());
	sql.append("SELECT * FROM myequipment " +
		   "WHERE tracking_no=\"" + track + "\"");
	rs = stmt.executeQuery(sql.toString());
	if (rs.next())
        {
	  equipment.add(rs.getString(2));
	  equipment.add(new Integer(rs.getInt(3)));
	  equipment.add(rs.getString(6));
	  equipment.add(new Integer(rs.getInt(7)));
	  equipment.add(rs.getString(14));
	  equipment.add(new Integer(rs.getInt(15)));
	  equipment.add(rs.getString(12));
	  equipment.add(new Integer(rs.getInt(13)));
	  equipment.add(rs.getString(10));
	  equipment.add(new Integer(rs.getInt(11)));
	  equipment.add(rs.getString(16));
	  equipment.add(new Integer(rs.getInt(17)));
	  equipment.add(rs.getString(30));
	  equipment.add(new Integer(rs.getInt(31)));
	  equipment.add(rs.getString(18));
	  equipment.add(new Integer(rs.getInt(19)));
	  equipment.add(rs.getString(20));
	  equipment.add(new Integer(rs.getInt(21)));
	  equipment.add(rs.getString(22));
	  equipment.add(new Integer(rs.getInt(23)));
	  equipment.add(rs.getString(4));
	  equipment.add(new Integer(rs.getInt(5)));
	  equipment.add(rs.getString(24));
	  equipment.add(new Integer(rs.getInt(25)));
	  equipment.add(rs.getString(8));
	  equipment.add(new Integer(rs.getInt(9)));
	  equipment.add(rs.getString(26));
	  equipment.add(new Integer(rs.getInt(27)));
	  equipment.add(rs.getString(28));
	  equipment.add(new Integer(rs.getInt(29)));
	}
      } // end else

      // Query from myorder table
      sql.delete(0, sql.length());
      sql.append("SELECT status, order_date, price FROM myorder " +
		 "WHERE tracking_no=\"" + track + "\"");
      rs = stmt.executeQuery(sql.toString());
      if (rs.next())
      {
	order.add(rs.getString(1));
	order.add(rs.getDate(2));
	order.add(new Float(rs.getFloat(3)));
      }

      // List ordered items to web browser
      listOrder(out, workstation, laptop, equipment, order, track,
		userName, emailAddr);

    }
    catch(SQLException e)
    {
      response.sendError(response.SC_ACCEPTED, "The request has been " +
			 "accepted, but it failed to complete due to " +
			 "an error querying the database.");
      out.println(e);
      return;
    }
  
  } // end doPost


  private void listOrder(PrintWriter out, Vector workstation, Vector laptop,
			 Vector equipment, Vector order, String track,
			 String name, String email)
  {
    int size;
    float price = 0;
    float subTotal;
    //float total = 0;
    String itemType;
    Inventory item = new Inventory();

    out.println("<HTML>\n" +
		"<HEAD>\n" +
		"  <STYLE><!--A{text-decoration:none}--></STYLE>\n" +
		"  <BODY BGCOLOR=\"IVORY\" TEXT=\"BLACK\" LINK=\"BLUE\" " +
		"VLINK=\"GREEN\" ALINK=\"MAGENTA\">\n" +
		"  <TITLE>Track Order</TITLE>\n" +
		"</HEAD>\n"); 

    out.println("<BODY>\n\n" +
		"Following listed your ordered items with tracking number <B>"+
		track + "</B>");

    out.println("\n<FORM METHOD=\"POST\" ACTION=\"ListTrackNo\">\n");

    out.println("<TABLE BORDER=1>\n" +
		"<TR>\n" +
		"  <TD ALIGN=CENTER><B>Item Description</B></TD>\n" +
		"  <TD ALIGN=CENTER><B>Unit Price (US$)</B></TD>\n" +
		"  <TD ALIGN=CENTER><B>Quantity</B></TD>\n" +
		"  <TD ALIGN=CENTER><B>Total Price (US$)</B></TD>\n" +
		"</TR><TR>");

    if ((size = laptop.size()) > 0)
    {
      itemType = (String) laptop.get(0);
      price = item.getItemPrice(item.getInventory(itemType));
      subTotal = price * (float) (((Integer) laptop.get(1)).intValue());
      //total = subTotal;
      out.println("  <TD>" + item.getItemDesc(itemType) + "</TD>\n" +
		  "  <TD ALIGN=RIGHT>" + price + "</TD>\n"+
		  "  <TD ALIGN=RIGHT>" + ((Integer) laptop.get(1)).intValue() +
		  "</TD>\n" +
		  "  <TD ALIGN=RIGHT>" + subTotal + "</TD>\n" +
		  "</TR><TR>");
    }
    else
    {
      if ((size = workstation.size()) > 0)
      {
	itemType = (String) workstation.get(0);
	if (itemType.compareToIgnoreCase("Pentium_Xeon-700Mhz") == 0)
	    price = (new Float(2590.00)).floatValue();
	if (itemType.compareToIgnoreCase("Pentium_III-800Mhz") == 0)
	    price = (new Float(349.00)).floatValue();
	if (itemType.compareToIgnoreCase("Pentium_III-1Ghz") == 0)
	    price = (new Float(615.00)).floatValue();
	subTotal = price * (float) (((Integer) workstation.get(1)).intValue());
        out.println("  <TD>" + item.getItemDesc(itemType) + "</TD>\n" +
		    "  <TD ALIGN=RIGHT>" + price + "</TD>\n" +
		    "  <TD ALIGN=RIGHT>" +
		    ((Integer) workstation.get(1)).intValue() + "</TD>\n" +
		    "  <TD ALIGN=RIGHT>" + subTotal + "</TD>\n" +
		    "</TR><TR>");
      }

      if ((size = equipment.size()) > 0)
      {
	for (int i = 0; i < 30; i += 2)
	{
	  itemType = (String) equipment.get(i);
	  if (itemType.compareToIgnoreCase("null") != 0)
	  {
	    price = item.getItemPrice(item.getInventory(itemType));
	    subTotal = price*(float)(((Integer)equipment.get(i+1)).intValue());
	    out.println("  <TD>" + item.getItemDesc(itemType) + "</TD>\n" +
			"  <TD ALIGN=RIGHT>" + price + "</TD>\n" +
			"  <TD ALIGN=RIGHT>" +
			((Integer) equipment.get(i+1)).intValue() + "</TD>\n" +
			"  <TD WIDTH=15% ALIGN=RIGHT>" + subTotal + "</TD>\n" +
			"</TR><TR>");
	  } // end inner if
	} // end for loop
      } // end outer if

    } // end outer else

    out.println("  <TD COLSPAN=4 ALIGN=RIGHT><B>" +
		((Float) order.get(2)).floatValue() + "</B></TD>\n" +
		"</TR><TR>");
    out.println("</TABLE>\n");
    out.println("<TABLE>");
    out.println("<TR>");

    out.println("  <TD>Order Date:</TD>\n" +
		"  <TD>" + order.get(1) + "</TD>\n" +
		"</TR><TR>");
    out.println("  <TD>Order Status:</TD>\n" +
		"  <TD>" + order.get(0) + "</TD>\n" +
		"</TR><TR>");

    out.println("  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"email\" " +
		"VALUE=\"" + email + "\"></TD>");
    out.println("</TR><TR>\n" +
		"  <TD><INPUT TYPE=\"HIDDEN\" NAME=\"user\" " +
		"VALUE=\"" + name + "\"></TD>");

    out.println("</TR><TR HEIGHT=100>\n" +
		"  <TD COLSPAN=2><INPUT TYPE=\"SUBMIT\" " +
		"VALUE=\"Track Another Order\"></TD>");

    out.println("</TR><TR HEIGHT=100>\n" +
		"  <TD COLSPAN=2>|&nbsp;" +
		"<A HREF=\"http://jsp.csci.unt.edu/chung/" +
		"index.html#Order\">Home</A>&nbsp;\n|&nbsp;" +
		"<A HREF=\"../jsp/begin_order_form.jsp?email=" + email +
		"\">Order Items</A>&nbsp;\n|&nbsp;" +
		"<A HREF=\"../jsp/cancel_order.jsp?email=" + email + "\">" +
		"Cancel order</A>&nbsp;\n|&nbsp;" +
		"<A HREF=\"../jsp/change_order.jsp?email=" + email + "\">" +
		"Change order</A>&nbsp;|</TD>");

    out.println("</TR>\n" +
		"</TABLE>\n" +
		"</FORM>\n\n" +
		"</BODY>\n" +
		"</HTML>");

  } // end listOrder

} // end TrackOrder
