import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CreateJobSearch extends HttpServlet
{
 private ConnectionPool connPool;
 private int MAXSIZE = 512;
 private int initialConnection = 10;
 private int maxConnection = 50;

 public void init() throws ServletException
 {
  String driver="org.gjt.mm.mysql.Driver";
  String url="jdbc:mysql://richese.csci.unt.edu/chung";
  String user="chung";
  String pwd ="chung";

  try
  {
   connPool = new ConnectionPool(driver,url,user,pwd,
                                 initialConnection,
                                 maxConnection, true);
  }
  catch(SQLException sqle)
  {
   System.err.println("Error making pool: " + sqle);
   getServletContext().log("Error making pool: " + sqle);
   connPool = null;
  }
 }

 public void destroy()
 {
  connPool.closeAllConnections();
  }

 public void doGet(HttpServletRequest request,
                   HttpServletResponse response)
 throws ServletException, IOException
 {
  doPost(request, response);
 }

 public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
 throws ServletException, IOException
 {
  int option =
  Integer.valueOf(request.getParameter("option")).intValue();
  response.setContentType("text/html");

  switch(option)
  {
    case 1 : processJobSeeker(request, response);
             break;
    case 2 : processEmployer(request, response);
    default: break;
  }  
   
 }// end of doPost

/**
 * processJobSeeker's method is to process Job Seeker create resume 
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processJobSeeker(HttpServletRequest request,
                              HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

  String skill1 = request.getParameter("skill1");
  String skill2 = request.getParameter("skill2");
  String skill3 = request.getParameter("skill3");
  String skill4 = request.getParameter("skill4");
  String skill5 = request.getParameter("skill5");
  String skill6 = request.getParameter("skill6");
  String resume = request.getParameter("resume");
  String email  = request.getParameter("email");
  boolean errorFlag = false;
 
  HttpSession currSession = request.getSession(false);
  String username = (String)currSession.getValue("user_session");

  if((username.length()<1)||(email.length()<1))
  {
   out.println("You have to login first! <A HREF=\"../index.html#Job\"> "+
               "Click here</a>");
   return;
  }

  StringBuffer sql = new StringBuffer(MAXSIZE);
  sql.append("UPDATE js_member SET ");

  if(resume.length() == 0)
  {
   errorFlag = true;
   out.println("<P>You must type more for your resume field</P>");
  }
  else
    sql.append("resume=\"" + resume + "\"");
 
  int countFill = 0;

  if(skill1.length()>0) 
  {
    countFill++;
    sql.append(", skill1=\"" + skill1 + "\"");
  }
  if(skill2.length()>0)
  {
    countFill++;
    sql.append(", skill2=\"" + skill2 + "\"");
  }
  if(skill3.length()>0) 
  {
    countFill++;
    sql.append(", skill3=\"" + skill3 + "\"");
  }
  if(skill4.length()>0)
  {
    countFill++;
    sql.append(", skill4=\"" + skill4 + "\"");
  }
  if(skill5.length()>0)
  {
    countFill++;
    sql.append(", skill5=\"" + skill5 + "\"");
  }
  if(skill6.length()>0)
  {
    countFill++;
    sql.append(", skill6=\"" + skill6 + "\"");
  }

  if(countFill < 1)
  {
   errorFlag = true;
   out.println("<P>You must at least fill one of the skill's field</P>");
   sql.delete(0,sql.length());
  }
  else
   sql.append(" WHERE email=\"" + email + "\""); 

  if(errorFlag == true)
  {
   out.println("<P>Press the BACK button on your browser to go back "+
               "to the previous page.</P>");
   return;
  } 

  Vector vec = new Vector();
  vec.addElement(sql.toString());

  int option = 1;
  errorFlag = connectDB(vec,option,out);
  if(errorFlag == true)
    return;
  
  String nextURL= response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);

  showPage(username,email,nextURL,option,out);

 }// end of processJobSeeker

/**
 * processEmployer's method is to process the employer login 
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processEmployer(HttpServletRequest request,
                             HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

  String email = request.getParameter("email");
 
  HttpSession session = request.getSession();    
  String username = (String)session.getValue("user_session");

  String title = request.getParameter("title");
  String description = request.getParameter("description");
  int position = Integer.parseInt(request.getParameter("position"));
  int salary = Integer.parseInt(request.getParameter("salary"));

  boolean errorFlag = false;

  if((username.length()<1)||(email.length()<1))
  {
    out.println("<p>You must login first! </p>");
    return;
  }
  if(title.length()<1)
  {
   errorFlag = true;
   out.println("<P>You must specify the title of the job</P>");
  }
  if(description.length()<1)
  {
   errorFlag = true;
   out.println("<P>You must specify the description of the job</p>");
  }
  if(position < 1)
  {
   errorFlag = true;
   out.println("<P>You must specify the number of position to be > 1</P>");
  }
  if(salary < 1)   
  {
   errorFlag = true;
   out.println("<P>You must specify the approriate salary</p>");
  }
  if(errorFlag == true)
  {
   out.println("<P>Press the BACK button on your browser to go " +
               "back to the previous page</P>");
   return;
  }

  int option = 2;

  // generate unique job's id -- 6 digits
  NumberGenerator numberGen = new NumberGenerator();
  int id = numberGen.generateInt();

  // check the DB to see whether the id has been generated before
  while(checkID(id,out) == true)
    id = numberGen.generateInt();

 
  Calendar cal = Calendar.getInstance();
  int year = cal.get(cal.YEAR);
  int month = cal.get(cal.MONTH)+1; // the month starts from 0 - 11
  int date = cal.get(cal.DATE);
  String posting_date = year + "-" + month + "-" + date;

  String job = "INSERT INTO js_job VALUES(\"" + id + "\",\"" +
               title + "\",\"" +
               description + "\",\"" +
               position + "\",\"" +
               salary + "\",\"" +
               posting_date + "\")"; 

  String post = "INSERT INTO js_post_search VALUES(\"" +
                email + "\",\"" + id + "\")";

  Vector vec = new Vector();
  vec.addElement(job);
  vec.addElement(post);

  String nextURL = response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);
 
  errorFlag = connectDB(vec,option,out);
  if(errorFlag)
    return;

  showPage(username,email,nextURL,option,out); 
 }// end of processEmployer
 
/**
 * checkID's method is to check to see whether the id number 
 * for job is already generated before. If it has generated
 * before, it will return true otherwise it will generate false.
 * @param  int id contains the id number to check
 * @return boolean true if it is unique id otherwise return false
 */
 public boolean checkID(int id, PrintWriter out)
 {
  boolean found = false; // assume id is unique
  ResultSet rs;
  Statement stmt;
  String check ="SELECT id FROM js_post_search";
  Vector vec = new Vector(); // to contain all the id from DB
  try
  {
   Connection connect = connPool.getConnection();
   stmt = connect.createStatement();
   rs = stmt.executeQuery(check);
   while(rs.next())
    vec.add(new Integer(rs.getInt(1)));
   
   int size = vec.size();
   if(size == 0)
    return found;
   for(int i=0; i<size; i++)
     if(id == ((Integer)vec.elementAt(i)).intValue())
     {
      vec.removeAllElements();
      found = true;
     }
  }
  catch(SQLException sqle)
  {
   out.println(sqle);
  }
  vec.removeAllElements();
  return found;
 }

/**
 * connectDB's method is to connect MySQL's server and store the info
 * It also verifies that the users have not register in the site
 * before. It has registered before, It would just forward the
 * users to the menu page. It also creates HttpSession for user
 * containing the username.
 * @param  Vector vec contains sql statements to execute
 *         int option contain 1 for job seeker & 2 for employer
 *         PrintWriter out 
 * @return true if succesfully write to DB else return false 
 */
 public boolean connectDB(Vector vec,
                          int option, 
                          PrintWriter out) 
 {
  ResultSet rs;
  Statement stmt;

  try
  {
   Connection connect = connPool.getConnection();
   stmt = connect.createStatement(); 

   for(int i=0;i<vec.size();i++)
     stmt.executeUpdate((String)vec.elementAt(i)); 
  }
  catch(SQLException sqle)
  {
   out.println("connectDB : " + sqle);
   return true;
  }
  return false; 
 } // end of connectDB's method

/**
 * showPage's method is to show confirmation page to user
 * @param  String username contains username
 *         String email contains email
 *         String nextURL contains next page to show
 *         int option contains 1 - job_seeker
 *                             2 - employer
 *         PrintWriter out
 * @return none
 */
 public void showPage(String username, String email,
                      String nextURL, int option,
                      PrintWriter out)
 {
  out.println("<html>");
  out.println("<body bgcolor=ivory link=blue alink=green vlink=magneta>");
  out.println("<BR></BR>");
  out.println("<p>You have succesfully create ");
  if(option == 1)
    out.println("your resumei. ");
  else
    out.println("your job posting. ");
  out.println("It will be up in a minute. You can modify it "+
              "later. </p>");
  out.println("<p>Click <a href=" + nextURL + ">here</a> " +
              "to continue.</p>");
  out.println("</body></html>");
 }

} // end of CreateJobSearch's class
