import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class JobSearchLogin extends HttpServlet
{
 private ConnectionPool connPool;
 private int MAXSIZE = 512;
 private int initialConnection = 10;
 private int maxConnection = 50;

 public void init() throws ServletException
 {
  String driver="org.gjt.mm.mysql.Driver";
  String url="jdbc:mysql://richese.csci.unt.edu/chung";
  String user="chung";
  String pwd ="chung";

  try
  {
   connPool = new ConnectionPool(driver,url,user,pwd,
                                 initialConnection,
                                 maxConnection, true);
  }
  catch(SQLException sqle)
  {
   System.err.println("Error making pool: " + sqle);
   getServletContext().log("Error making pool: " + sqle);
   connPool = null;
  }
 }

 public void destroy()
 {
  connPool.closeAllConnections();
 }

 public void doGet(HttpServletRequest request,
                   HttpServletResponse response)
 throws ServletException, IOException
 {
  doPost(request, response);
 }

 public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
 throws ServletException, IOException
 {
  int option =
  Integer.valueOf(request.getParameter("login")).intValue();

  response.setContentType("text/html");

  switch(option)
  {
    case 1 : processJobSeeker(request, response);
             break;
    case 2 : processEmployer(request, response);
    default: break;
  }  
   
 }// end of doPost

/**
 * processJobSeeker's method is to process Job Seeker Login process
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processJobSeeker(HttpServletRequest request,
                              HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

  String pass = request.getParameter("pwd");
  String email = request.getParameter("email");

  boolean flag = false;

  if(pass == null)
  {
   out.println("<br><b>Need to fill in <i>password</i></b></br>");
   flag = true;
  }
  if(email == null)
  {
   out.println("<br><b>Need to fill in <i>email</i></b></br>");
   flag = true;
  }
  if(flag == true)
  {
   out.println("<br><b>Press the BACK button to go back to the previous "+
               "page</b></br>");
   return;
  }

  String sql = "SELECT name, email, password FROM js_member "+
               "WHERE email=\"" + email + "\"";

  int option = 1;

  String nextURL= response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);

  connectDB(sql,pass,email,nextURL,option,out,request,response);

  String wrongURL ="http://jsp.csci.unt.edu/chindraw/wrong1.html";
  response.sendRedirect(response.encodeURL(wrongURL));
 }// end of processJobSeeker

/**
 * processEmployer's method is to process the employer login 
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processEmployer(HttpServletRequest request,
                             HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

  int option = 2;

  String email = request.getParameter("email");
  String pass = request.getParameter("pwd");
   
  boolean flag = false;

  if(pass == null)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>password</i></b></br> ");
  }
  if(email == null)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>email</i></b></br> ");
  }
  if(flag == true)
  {
   out.println("<BR><B>Press the BACK button on your browser to " +
               "go back to the previous page.</b></br>");
   return;
  }

  String sql = "SELECT name, email, password FROM js_member " +
               "WHERE email=\"" + email + "\"";

 
  String nextURL = response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);
 
  connectDB(sql,pass,email,nextURL,option,out,request,response);
  
 }// end of processEmployer
 
/**
 * connectDB's method is to connect MySQL's server and store the info
 * It also verifies that the users have not register in the site
 * before. It has registered before, It would just forward the
 * users to the menu page. It also creates HttpSession for user
 * containing the username.
 * @param  String sql contains sql statements to execute
 *         String pass contains user password
 *         String email contains the user's email
 *         String nextURL contains the next page          
 *         PrintWriter out 
 *         HttpRequest request contains user request
 * @return none
 */
 public void connectDB(String sql, String pass, 
                       String email,String nextURL,
                       int option, PrintWriter out, 
                       HttpServletRequest request,
                       HttpServletResponse response)
 {
  ResultSet rs;
  Statement stmt;
  
  String wrongURL;
  if(option == 1)
    wrongURL ="http://jsp.csci.unt.edu/chindraw/wrong1.html"; 
  else 
    wrongURL ="http://jsp.csci.unt.edu/chindraw/wrong2.html";
  try
  {
   Connection connect = connPool.getConnection();
   stmt = connect.createStatement(); 
   rs = stmt.executeQuery(sql);
 
   if(rs.next())
   {
    if((rs.getString(1).compareToIgnoreCase(email) == 0) &&
       (rs.getString(4).compareTo(pass)==0))
     {
      String username = rs.getString(3);
      HttpSession currSession = request.getSession(true);
      currSession.putValue("user_session",username);
      response.sendRedirect(nextURL);
     }//if-statement
     else
     {
      response.sendRedirect(response.encodeURL(wrongURL));
     }
   }// end if 
   
  }
  catch(SQLException sqle)
  {
   out.println(sqle);
  }
  catch(IOException ioex)
  {
   out.println(ioex);
  }
 } // end of connectDB's method


} // end of JobSearchRegister's class
