import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class JobSearchRegister extends HttpServlet
{
 private ConnectionPool connPool;
 private int MAXSIZE = 512;
 private int initialConnection = 10;
 private int maxConnection = 50;

 public void init() throws ServletException
 {
  String driver="org.gjt.mm.mysql.Driver";
  String url="jdbc:mysql://richese.csci.unt.edu/chung";
  String user="chung";
  String pwd ="chung";

  try
  {
   connPool = new ConnectionPool(driver,url,user,pwd,
                                 initialConnection,
                                 maxConnection, true);
  }
  catch(SQLException sqle)
  {
   System.err.println("Error making pool: " + sqle);
   getServletContext().log("Error making pool: " + sqle);
   connPool = null;
  }
 }

 public void destroy()
 {
  connPool.closeAllConnections();
 }

 public void doGet(HttpServletRequest request,
                   HttpServletResponse response)
 throws ServletException, IOException
 {
  doPost(request, response);
 }

 public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
 throws ServletException, IOException
 {
  int option =
  Integer.valueOf(request.getParameter("register")).intValue();

  response.setContentType("text/html");

  switch(option)
  {
    case 1 : processJobSeeker(request, response);
             break;
    case 2 : processEmployer(request, response);
    default: break;
  }  
   
 }// end of doPost

/**
 * processJobSeeker's method is to process the information that
 * the job seekers submit to the site. The method would check if
 * the job seekers have fill in all the fields required. If
 * the job seekers have not fill in one of the field, the method
 * would return the job seekers to the previous site. Once
 * the job seekers have fill in all the info, the method would
 * check to see whether they have registered in the site before,
 * if they have register, the method would forward them to menu
 * page, else it would write their info to DB and forward them to
 * the menu page.
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processJobSeeker(HttpServletRequest request,
                              HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

  String username = request.getParameter("name");
  String street = request.getParameter("street");
  String city = request.getParameter("city");
  String state = request.getParameter("state");
  String zip = request.getParameter("zip");
  String phone = request.getParameter("phone");
  String pass = request.getParameter("password");
  String vpass = request.getParameter("vpassword");
  String email = request.getParameter("email");
  String degtype = request.getParameter("degType");

  boolean flag = false;

  if(username.length()<1)       
  {
   out.println("<BR><B>Need to fill in <i>name</i></b></BR>");
   flag = true;
  }
  if(street.length()<1)
  {
   out.println("<BR><B>Need to fill in <i>street</i></b></br>");
   flag = true;
  }
  if(city.length()<1)
  {
   out.println("<BR><B>Need to fill in <i>city</i></b></br>");
   flag = true;
  }
  if(zip.length()<1)
  {
   out.println("<BR><B>Need to fill in <i>zip code</i></b></br>");
   flag = true; 
  }
  if(phone.length()<1)
  {
   out.println("<BR><B>Need to fill in <i>telephone</i></b></br>");
   flag = true;
  }
  if(degtype.length()<1)
  {
   out.println("<BR><B>Need to fill in <i>degree type</i></b></br>");
   flag = true;
  }
  if(pass.length()<1)
  {
   out.println("<br><b>Need to fill in <i>password</i></b></br>");
   flag = true;
  }
  if(vpass.length()<1)
  {
   out.println("<BR><B>Need to fill in <i>verify password</i></b></br>");
   flag = true;
  }
  if(email.length()<1)
  {
   out.println("<br><b>Need to fill in <i>email</i></b></br>");
   flag = true;
  }
  if(pass.compareTo(vpass) != 0)
  {
   out.println("<br><b>Your password does not match</b></br>");
   flag = true;
  }   
  if(flag == true)
  {
   out.println("<br><b>Press the BACK button to go back to the previous "+
               "page</b></br>");
   return;
  }

  StringBuffer contact = new StringBuffer(MAXSIZE);
  StringBuffer sqlJS = new StringBuffer(MAXSIZE);
  StringBuffer info = new StringBuffer(MAXSIZE);
  StringBuffer post = new StringBuffer(MAXSIZE);

  int option = 1;
  int id = 0;

  sqlJS.append("INSERT INTO js_member VALUES(\""+
  email + "\","+option+", null ,\"" + username + "\",\"" +
  pass +"\",\""+degtype+"\",null,null,"+
  "null,null,null,null,null)");
 
  info.append("INSERT INTO js_contact_info VALUES(\""+
  email + "\",\"" + street + "\",\"" + city + "\",\""+
  state + "\",\"" + zip + "\",\"" + phone + "\")");

  contact.append("INSERT INTO js_contact VALUES(\""+
  email + "\")"); 

  post.append("INSERT INTO js_post_search VALUES(\""+
  email + "\"," + id + ")");

  Vector vec = new Vector();

  vec.addElement(sqlJS.toString());
  vec.addElement(info.toString()); 
  vec.addElement(contact.toString());
  vec.addElement(post.toString());

  String nextURL= response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);

  connectDB(vec,username,pass,email,nextURL,out,request);

 }// end of processJobSeeker

/**
 * processEmployer's method is to process the registration of
 * the employer. If the employer misses to fill in one of the fields,
 * the servlet would return the employer to previous page.
 * Else the method would collect all of information and store it
 * the database. Before It stores the info to database, It checks
 * to see whether the employers have register in the site before.
 * If the employer has registered before, the method would 
 * forward the employer to the menu's page.
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processEmployer(HttpServletRequest request,
                             HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

  int option = 2;

  String companyname = request.getParameter("companyname");
  String username = request.getParameter("contactperson");
  String phone = request.getParameter("phone");
  String street = request.getParameter("companyaddress");
  String city = request.getParameter("companycity");
  String state = request.getParameter("companystate");
  String zip = request.getParameter("zip");
  String email = request.getParameter("email");
  String pass = request.getParameter("password");
  String vpass = request.getParameter("vpassword");
   
  boolean flag = false;

  if(username.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>contact person name</i></b></br>");
  }
  if(companyname.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>company name</i></b></br>");
  }
  if(pass.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>password</i></b></br> ");
  }
  if(vpass.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>verify password</i></b></br> ");
  }
  if(email.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>email</i></b></br> ");
  }
  if(state.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>state</i></b></br> ");
  }
  if(city.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>city</i></b></br> ");
  }
  if(phone.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>phone</i></b></br> ");
  }
  if(zip.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>zip code</i></b></br> ");
  }
  if(street.length()<1)
  {
   flag = true;
   out.println("<BR><B>Need to fill in <i>street</i></b></br> ");
  }
  if(pass.compareTo(vpass) != 0)
  {
   flag = true;
   out.println("<BR><B>Your password does not match</b></br>");
  }
  if(flag == true)
  {
   out.println("<BR><B>Press the BACK button on your browser to " +
               "go back to the previous page.</b></br>");
   return;
  }

  int id = 0;

  StringBuffer sqlEM = new StringBuffer(MAXSIZE);
  StringBuffer info = new StringBuffer(MAXSIZE);
  StringBuffer contact = new StringBuffer(MAXSIZE);
  StringBuffer post = new StringBuffer(MAXSIZE);

  sqlEM.append("INSERT INTO js_member VALUES(\""+
  email + "\"," + option +",\"" + companyname + "\",\"" + username +
  "\",\"" + pass + "\",\"null\",\"null\",\""+
  "null\",\"null\",\"null\",\"null\",\"null\",\"null\")");

  info.append("INSERT INTO js_contact_info VALUES(\""+
  email + "\",\"" + street + "\",\"" + city + "\",\""+
  state + "\",\"" + zip + "\",\"" + phone + "\")");

  contact.append("INSERT INTO js_contact VALUES(\""+
  email + "\")"); 
 
  post.append("INSERT INTO js_post_search VALUES(\""+
  email + "\"," + id + ")");

  Vector vec = new Vector();

  vec.addElement(sqlEM.toString());
  vec.addElement(info.toString()); 
  vec.addElement(contact.toString());
  vec.addElement(post.toString());

  String nextURL= response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);
 
  connectDB(vec,username,pass,email,nextURL,out,request);

 }// end of processEmployer
 
/**
 * connectDB's method is to connect MySQL's server and store the info
 * It also verifies that the users have not register in the site
 * before. It has registered before, It would just forward the
 * users to the menu page. It also creates HttpSession for user
 * containing the username.
 * @param  Vector vec contains sql statements to execute
 *         String username contains the user name
 *         String pass contains user password
 *         String email contains the user's email
 *         String nextURL contains the next URL to go to
 *         PrintWriter out 
 *         HttpRequest request contains user request
 * @return none
 */
 public void connectDB(Vector vec,String username, String pass,
                       String email, String nextURL,
                       PrintWriter out, HttpServletRequest request)
 {
  ResultSet rs;
  Statement stmt;

  String verify = new String("SELECT * FROM js_member");
  
  try
  {
   Connection connect = connPool.getConnection();
   stmt = connect.createStatement(); 
   rs = stmt.executeQuery(verify);
 
   while(rs.next())
   {
    if(rs.getString(1).compareToIgnoreCase(email) == 0)
    {
     if((rs.getString(3).compareToIgnoreCase(username)==0) &&
       (rs.getString(4).compareTo(pass)==0))
     {
      HttpSession currSession = request.getSession(true);
      currSession.putValue("user_session",username);
      out.println("<P>You must have registered in this site before "+
                  "Please click <a href="+nextURL+">here</a> " +
                  "to continue. </p>");
      return;
     }//if-statement
     else
     {
      out.println("<P>We find your email streetess in our database. "+
                  "However, your name and your password do not match "+
                  " with the information that we have in database. " +
                  "Either you use another email to register, "+
                  "or you contact sysadmin@box.com to fix this problem "+
                  "</p>");
      return;
     }// else-statement
    }// if-statement 
   }// end of while loop
   
   for(int i=0;i<vec.size();i++)
     stmt.executeQuery((String)vec.elementAt(i));
   
   HttpSession currSession = request.getSession(true);
   currSession.putValue("user_session",username);
   showPage(username,nextURL,out);
  }
  catch(SQLException sqle)
  {
   out.println(sqle);
  }

 } // end of connectDB's method

/**
 * showPage's method is to show the confirmation page
 * @param  String username contains user name
 *         String nextURL contains the destination page
 *         PrintWriter out 
 * @return none
 */
 public void showPage(String username, String nextURL, PrintWriter out)
 {
  out.println("<HTML><HEAD><TITLE>Confirmation of Registration "+
              "for " + username);
  out.println("</TITLE></HEAD>");
  out.println("<BODY BGCOLOR=IVORY LINK=BLUE ALINK=GREEN VLINK=MAGNETA>");
  out.println("<BR></BR>");
  out.println("<font face=arial size=+3>Confirmation for <B>" +
              username + "</B></font>");
  out.println("<BR></BR>");
  out.println("<BR>You have successfully register in this site "+
              "Please click <a href=" + nextURL + ">here</a> " +
              "to continue.</BR>"); 
  out.println("</BODY></HTML>");
 }

} // end of JobSearchRegister's class
