import java.sql.*;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ModifyJobSearch extends HttpServlet
{
 private ConnectionPool connPool;
 private int MAXSIZE = 512;
 private int initialConnection = 10;
 private int maxConnection = 50;

 public void init() throws ServletException
 {
  String driver="org.gjt.mm.mysql.Driver";
  String url="jdbc:mysql://richese.csci.unt.edu/chung";
  String user="chung";
  String pwd ="chung";

  try
  {
   connPool = new ConnectionPool(driver,url,user,pwd,
                                 initialConnection,
                                 maxConnection, true);
  }
  catch(SQLException sqle)
  {
   System.err.println("Error making pool: " + sqle);
   getServletContext().log("Error making pool: " + sqle);
   connPool = null;
  }
 }

 public void destroy()
 {
  connPool.closeAllConnections();
  }

 public void doGet(HttpServletRequest request,
                   HttpServletResponse response)
 throws ServletException, IOException
 {
  doPost(request, response);
 }

 public void doPost(HttpServletRequest request,
                    HttpServletResponse response)
 throws ServletException, IOException
 {
  int option = 
  Integer.valueOf(request.getParameter("option")).intValue();

  response.setContentType("text/html");

  switch(option)
  {
    case 1 : processJobSeeker(request, response);
             break;
    case 2 : processEmployer(request, response);
    default: break;
  }  
   
 }// end of doPost

/**
 * processJobSeeker's method is to process Job Seeker Login process
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processJobSeeker(HttpServletRequest request,
                              HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

  String skill1 = request.getParameter("skill1");
  String skill2 = request.getParameter("skill2");
  String skill3 = request.getParameter("skill3");
  String skill4 = request.getParameter("skill4");
  String skill5 = request.getParameter("skill5");
  String skill6 = request.getParameter("skill6");
  String resume = request.getParameter("resume");
  String email  = request.getParameter("email");
  String street = request.getParameter("street");
  String city   = request.getParameter("city");
  String state  = request.getParameter("state");
  String zip    = request.getParameter("zip");
  String phone  = request.getParameter("phone");
  String degType= request.getParameter("degType");
  String pass   = request.getParameter("pwd");
  HttpSession currSession = request.getSession();
  String username = (String)currSession.getValue("user_session");
  boolean errorFlag = false;
  if((username.length()<1)||(email.length()<1))
  {
   out.println("You have to login first! <A HREF=\"../index.html#Job\"> "+
               "Click here</a>");
   errorFlag = true;
  }
 
  if(pass.length()==0)
  {
   out.println("<p>You must fill the password! </P>");
   errorFlag = true;
  }
  if(errorFlag == true)
  {
   out.println("<P>Press the BACK button on your browser to go back "+
               "to the previous page.</P>");
   return;
  } 

  Vector vec = new Vector();
  StringBuffer sql = new StringBuffer(MAXSIZE);
  StringBuffer contact = new StringBuffer(MAXSIZE);

  int count = 0;
  sql.append("UPDATE js_member SET ");
  if(degType.length()>0 )
  {
    sql.append("degree=\"" + degType+ "\"");
    count++;
  }
  if(resume.length()>0)
  {
    if(count>0)
      sql.append(",");
    sql.append("resume=\"" + resume + "\"");
    count++;
  }
  if(skill1.length()>0)
  {
    if(count>0)
      sql.append(",");
    sql.append("skill1=\"" + skill1 + "\"");
    count++;
  }
  if(skill2.length()>0)
  {
    if(count>0)
      sql.append(",");
    sql.append("skill2=\"" + skill2 + "\"");
    count++;
  }
  if(skill3.length()>0)
  {
    if(count>0)
      sql.append(",");
    sql.append("skill3=\"" + skill3 + "\"");
    count++;
  }
  if(skill4.length()>0)
  {
    if(count>0)
      sql.append(",");
    sql.append("skill4=\"" + skill4 + "\"");
    count++;
  }
  if(skill5.length()>0)
  {
    if(count>0)
      sql.append(",");
    sql.append("skill5=\"" + skill5 + "\"");
    count++;
  }
  if(skill6.length()>0)
  {
    if(count>0)
      sql.append(",");
    sql.append("skill6=\"" + skill6 + "\"");
    count++;
  }
  if(count>0)
  {
    sql.append(" WHERE email=\"" + email + "\"");
    vec.addElement(sql.toString());
  }
  else
    sql.delete(0, sql.length());
  count = 0;
  contact.append("UPDATE js_contact_info SET ");
  if(street.length()>0)
  {
   contact.append("street=\"" + street + "\"");
   count++;
  }
  if(city.length()>0)
  {
   if(count>0)
     contact.append(",");
   contact.append("city=\"" + city + "\"");
   count++;
  }
  if(state.length()>0)
  {
   if(count>0)
     contact.append(",");
   contact.append("state=\"" + state + "\"");
   count++;
  }
  if(zip.length()>0)
  {
   if(count>0)
     contact.append(",");
   contact.append("zip=\"" + zip + "\"");
   count++;
  }
  if(phone.length()>0)
  {
   if(count>0)
     contact.append(",");
   contact.append("phone=\"" + phone + "\"");
   count++;
  }
  if(count>0)
  {
   contact.append(" WHERE email=\"" + email + "\"");
   vec.addElement(contact.toString());
  }
  else
    contact.delete(0,contact.length());
  int option = 1;
  errorFlag = connectDB(vec,out);
  if(errorFlag == true)
    return;
  

  String nextURL= response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);

  showPage(username,nextURL,option,out);

 }// end of processJobSeeker

/**
 * processEmployer's method is to process the employer login 
 * @param  HttpServletRequest request
 *         HttpServletResponse response
 * @return none
 */
 public void processEmployer(HttpServletRequest request,
                             HttpServletResponse response)
 throws ServletException, IOException
 {
  PrintWriter out = response.getWriter();

 
  HttpSession session = request.getSession();    
  String username = (String)session.getValue("user_session");
  
  String tmpID = request.getParameter("id");
  String title = request.getParameter("title");
  String email = request.getParameter("email");
  String description = request.getParameter("description");
  String positions =   request.getParameter("position");
  String salaries = request.getParameter("salary");
  String pass = request.getParameter("pwd");

  boolean errorFlag = false;
 

  if((username.length()<1)||(email.length()<1))
  {
    out.println("<p>You must login first! </p>");
    errorFlag = true;
  }
  if(tmpID.length()<1)
  {
    out.println("<P>You must fill in the Job ID </p>");
    errorFlag = true;
  }
  if(pass.length()<1)
  {
    out.println("<P>You must fill in password </P>");
    errorFlag = true;
  }
  if(errorFlag == true)
  {
   out.println("<P>PresE the BACK button on your browser to go " +
               "back to the previous page</P>");
   return;
  }

  int id = Integer.parseInt(tmpID);
  int option = 2;
  int count = 0;
 
  Calendar cal = Calendar.getInstance();
  int year = cal.get(cal.YEAR);
  int month = cal.get(cal.MONTH)+1; // the month starts from 0 - 11
  int date = cal.get(cal.DATE);
  String posting_date = year + "-" + month + "-" + date;
 
  Vector vec = new Vector();
 
  StringBuffer job = new StringBuffer(MAXSIZE);
  job.append("UPDATE js_job SET ");
  if(title.length()>0)
  {
   job.append("title=\"" + title + "\"");
   count++;
  }
  if(description.length()>0)
  {
   if(count>0)
     job.append(",");
   job.append("description=\"" + description + "\"");
   count++;
  }
  if(positions.length()>0)
  {
   if(count>0)
     job.append(",");
   int position = Integer.parseInt(positions);
   job.append("positions=\"" + position + "\"");
   count++;
  }
  if(salaries.length()>0)
  {
   if(count>0)
     job.append(",");
   int salary = Integer.parseInt(salaries); 
   job.append("salary=\"" + salary + "\"");
   count++;
  }
  if(count>0)
  {
   job.append(",posting_date=\""+ posting_date + "\" " +
              "WHERE id=\"" + id + "\"");
   vec.addElement(job.toString());
  }
  else
    job.delete(0,job.length()); 

  errorFlag = connectDB(vec,out);
  if(errorFlag == true)
    return;

  String nextURL = response.encodeURL(
  "http://jsp.csci.unt.edu/chindraw/jsp/JobMenu.jsp?" +
  "option=" + option + "&email=" + email);

  showPage(username,nextURL,option,out); 
 }// end of processEmployer
 

/**
 * connectDB's method is to connect MySQL's server and store the info
 * @param  Vector vec contains sql statements to execute
 *         PrintWriter out 
 * @return false if succesfully write to DB else return true
 *         indicating there are an errors occur 
 */
 public boolean connectDB(Vector vec,
                          PrintWriter out) 
 {
  if(vec.size()  == 0)
    return false;

  ResultSet rs;
  Statement stmt;
  
  try
  {
   Connection connect = connPool.getConnection();
   stmt = connect.createStatement(); 

   for(int i=0;i<vec.size();i++)
     stmt.executeUpdate((String)vec.elementAt(i)); 
   
  }
  catch(SQLException sqle)
  {
   out.println("connectDB : " + sqle);
   return true;
  }

  return false; 
 } // end of connectDB's method

/**
 * showPage's method is to show confirmation page to user
 * @param  String username contains username
 *         String nextURL contains next page to show
 *         int option contains 1 - job_seeker
 *                             2 - employer
 *         PrintWriter out
 * @return none
 */
 public void showPage(String username, 
                      String nextURL, int option,
                      PrintWriter out)
 {
  out.println("<HTML><HEAD><TITLE>");
  out.println("Confirmation page for modifying ");
  if(option == 1)
    out.println("resume of " + username);
  else
    out.println("job poting of " + username);
  out.println("</TITLE></HEAD>");
  out.println("<BODY BGCOLOR=IVORY LINK=BLUE ALINK=GREEN VLINK=MAGNETA>");     
  out.println("<BR></BR>");
  out.println("<p>You have succesfully modify ");
  if(option == 1)
    out.println("your resume. ");
  else
    out.println("your job posting. ");
  out.println("It will be up in a minute. You can view/modify it "+
              "later. </p>");
  out.println("<p>Click <a href=" + nextURL + ">here</a> " +
              "to continue.</p>");
  out.println("</BODY></HTML>");
 }

} // end of JobSearchRegister's class
